// TestCaseAocsData_5.cpp
//
// Version	1.0
// Date		13.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include <math.h>

#include "TestCaseAocsData_5.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsData/AocsData.h"
#include "../../AocsData/TwoEulerAngles.h"
#include "../../AocsData/DataItemWrite.h"
#include "../../AocsData/DataItemRead.h"
#include "../../OperatingSystemObjects/DummyAocsClock.h"

// -------------------------------------------------------------------
TestCaseAocsData_5::TestCaseAocsData_5():
	TestCaseGenericSetUp(ID_AOCSDATA*10+5,"TestCaseAocsData_5") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsData_5::runTestCase() {

	TwoEulerAngles e1;

	// Reset the two AOCS data
	e1.reset();

	// Get the write access to the AOCS data item
	DataItemWrite w10 = e1.getDataItemWrite(0);
	DataItemWrite w11 = e1.getDataItemWrite(1);

	// Advance time
	aocsClock.run(0);	

	// Set the first component of TwoEulerAngles object and get time
	w10.set(1);
	AocsTime time1 = aocsClock.getTime();

	// Advance time again, set the second component of the TwoEulerAngles object and get time
	aocsClock.run(0);	
	w11.set(2);
	AocsTime time2 = aocsClock.getTime();

	// Check correct value of time tags
	if (e1.getTimeTag(0) != time1)
	{	setTestResult(TEST_FAILURE, "Incorrect time tag");
		return;
	}

	if (e1.getTimeTag(1) != time2)
	{	setTestResult(TEST_FAILURE, "Incorrect time tag");
		return;
	}

	if (e1.getEarliestTimeTag() != time1)
	{	setTestResult(TEST_FAILURE, "Incorrect time tag");
		return;
	}

	if (e1.getLatestTimeTag() != time2)
	{	setTestResult(TEST_FAILURE, "Incorrect time tag");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
