// TestCaseAocsData_8.cpp
//
// Version	1.0
// Date		13.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include <math.h>

#include "TestCaseAocsData_8.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsData/AttitudeDataPool.h"
#include "../../AocsData/DataItemWrite.h"
#include "../../AocsData/DataItemRead.h"

// -------------------------------------------------------------------
TestCaseAocsData_8::TestCaseAocsData_8():
	TestCaseGenericSetUp(ID_AOCSDATA*10+8,"TestCaseAocsData_8") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsData_8::runTestCase() {

	AttitudeDataPool attitudeDataPool;

	// Reset the data pool
	attitudeDataPool.reset();

	// Iterate through the data in the pool 
	int i=0;
	#define N 14				// there are 14 data in the pool
	AocsData* dataList[N];		
	for ( AocsData* data=attitudeDataPool.first();
						!attitudeDataPool.isLast();
							data=attitudeDataPool.next() )
	{	dataList[i] = data;
		i++;
	}

	// Check that only four data were retrieved
	if ( i != N )
	{	setTestResult(TEST_FAILURE, "Incorrect number of data was retrieved");
		return;
	}

	// Check that correct data were retrieved
	if (dataList[0] != attitudeDataPool.getFssData() )
	{	setTestResult(TEST_FAILURE, "Incorrect data was retrieved");
		return;
	}

	if (dataList[1] != attitudeDataPool.getGyrRate() )
	{	setTestResult(TEST_FAILURE, "Incorrect data was retrieved");
		return;
	}

	if (dataList[2] != attitudeDataPool.getSas1Data() )
	{	setTestResult(TEST_FAILURE, "Incorrect data was retrieved");
		return;
	}

	if (dataList[3] != attitudeDataPool.getSas2Data() )
	{	setTestResult(TEST_FAILURE, "Incorrect data was retrieved");
		return;
	}

	if (dataList[4] != attitudeDataPool.getSas3Data() )
	{	setTestResult(TEST_FAILURE, "Incorrect data was retrieved");
		return;
	}

	// Check that no failure or configuration events have been created
	if ( failureEvtRep.getCounter() != failureEvtN )
	{	setTestResult(TEST_FAILURE, "Failure event was generated");
		return;
	}

	if ( configEvtRep.getCounter() != configEvtN )
	{	setTestResult(TEST_FAILURE, "Configuration event was generated");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
