// DataItemWrite.cpp
//
// Version	1.0
// Date		10.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../GeneralInclude/Include.h"
#include "../BasicObjects/Configurable.h"
#include "../TelemetryManagement/Telemeterable.h"
#include "../BasicObjects/Resettable.h"
#include "../BasicObjects/RootObject.h"
#include "../BasicObjects/AocsObject.h"
#include "../OperatingSystemObjects/AocsClock.h"
#include "DataItemRead.h"
#include "DataItemWrite.h"

// -------------------------------------------------------------------
// Define static variables
AocsClock*	DataItemWrite::aocsClock=NULL;

// -------------------------------------------------------------------

DataItemWrite::DataItemWrite()				
{
	setClassId(ID_DATAITEMWRITE);			

	datum = NULL;
	timeTag = NULL;
}

// -------------------------------------------------------------------

DataItemWrite::DataItemWrite(AocsTime* t, Real* d)
{
	setClassId(ID_DATAITEMWRITE);			

	datum = d;
	timeTag = t;
}

// -------------------------------------------------------------------

void DataItemWrite::set(Real newValue)
{ 
	*timeTag = aocsClock->getTime();
	*datum = newValue;
}

// -------------------------------------------------------------------

void DataItemWrite::setAocsClock(AocsClock* c)
{ 
	aocsClock = c;
}

// -------------------------------------------------------------------

bool DataItemWrite::isDataItemWriteConfigured()
{
	if (!isDataItemReadConfigured())
		return false;

	if ((timeTag==NULL) || (aocsClock==NULL))
		return false;

	return true;
}