// DataItemWrite.h
//
// Version	1.0
// Date		10.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#ifndef DataItemWriteH
#define DataItemWriteH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../AocsData/DataItemRead.h"

// -------------------------------------------------------------------

class DataItemWrite : public DataItemRead {

	AocsTime* timeTag;		

	static AocsClock* aocsClock;  // clock is used to attach time tag to data values
	
	static ClassId classId;

public :

	DataItemWrite();
	void initialize(AocsTime* t, Real* d)
		{ timeTag = t; datum = d;}

	DataItemWrite(AocsTime* timeTag, Real* datum);

	void set(Real newValue);

	static void setAocsClock(AocsClock* aocsClock);

	bool isDataItemWriteConfigured();
};

// -------------------------------------------------------------------
#endif
