// NVector.h
//
// Version	1.0
// Date		06.07.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// AOCS data consisting of a vector of n elements
// -------------------------------------------------------------------

#ifndef NVectorH
#define NVectorH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../AocsData/AocsData.h"

// -------------------------------------------------------------------

class NVector: public AocsData {			

	static int tmImageLength[NTMFORMATS];

	int numberOfElements;

protected :

	virtual void setTmImageLength(TelemetryFormat fmt, int v)
		{ tmImageLength[fmt] = v; }
	virtual int getLocalTelemetryImageLength(TelemetryFormat fmt)
		{ return tmImageLength[fmt]; }

public :

	NVector(int numberOfElements);

	virtual int getNumberOfItems()
		{ return numberOfElements; }

};

// -------------------------------------------------------------------
#endif