// Scalar.cpp
//
// Version	1.0
// Date		10.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../AocsData/Scalar.h"
#include "../AocsData/AocsData.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------
// Define static variables
int Scalar::tmImageLength[NTMFORMATS];

// -------------------------------------------------------------------
// Default constructor.

Scalar::Scalar()				
{
	setClassId(ID_SCALAR);			// assign class identifier

	format = scalar;				// assign AOCS data format

	initialize();					// see comment at the method definition

	reset();						// see comment on AocsData constructor
	resetConfiguration();			// see comment on AocsData constructor
}

// -------------------------------------------------------------------

Real Scalar::distance(AocsData* d)
{
	if (d == NULL)		// distance from zero
		if (getDataItemValue(0)>0)
			return getDataItemValue(0);
		else
			return (-getDataItemValue(0));
	
	if (d->getFormat() != getFormat())		
	{	reportConfigurationError(this,INCOMPATIBLE_DATA_ITEMS,this);
		return LARGE_REAL;
	}
	else
		if ( getDataItemValue(0) > (((Scalar*)d)->getDataItemValue(0)) )
			return ( getDataItemValue(0) - (((Scalar*)d)->getDataItemValue(0)) );
		else
			return ( (((Scalar*)d)->getDataItemValue(0)) - getDataItemValue(0) );
}

