// Scalar.h
//
// Version	1.0
// Date		11.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#ifndef ScalarH
#define ScalarH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../AocsData/AocsData.h"

// -------------------------------------------------------------------

class Scalar: public AocsData {			

	static int tmImageLength[NTMFORMATS];

protected :

	virtual void setTmImageLength(TelemetryFormat fmt, int v)
		{ tmImageLength[fmt] = v; }
	virtual int getLocalTelemetryImageLength(TelemetryFormat fmt)
		{ return tmImageLength[fmt]; }

public :

	Scalar();

	virtual int getNumberOfItems()
		{ return 1; }

	virtual Real distance(AocsData* d);		// distance = absolute value 
											// of difference
};

// -------------------------------------------------------------------
#endif