// AocsEvent.h
//
// Version	1.0
// Date		14.01.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Base class for all events
//
// -------------------------------------------------------------------

#ifndef AocsEventH
#define AocsEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

class AocsEvent : public AocsObject {

	AocsTime timeStamp;			// time when event was created
	AocsObject* creator;		// object that created the event
	EventType evtType;			// event type identifier
	static int tmImageLength[NTMFORMATS];

	void localResetConfiguration();

public :

	AocsEvent();

	void initialize(AocsObject* creator, EventType evtType);

	AocsTime getTimeStamp()
		{ return timeStamp; }

	EventType getEventType()
		{ return evtType; }

	AocsObject* getCreator()
		{ return creator; }

	virtual void resetConfiguration();	// pure virtual methods from Configurable	
	virtual bool isConfigured();		

										// pure virtual methods from Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif
