// TestCaseAocsEvent.h
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Abstract base class for test cases for classes AocsEvent and
// AocsEventRepository.
//
// -------------------------------------------------------------------

#ifndef TestCaseAocsEventH
#define TestCaseAocsEventH

#include "../../GeneralUtilities/TestCase.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../AocsEvent/ConfigurationEventRepository.h"
#include "../../AocsEvent/FailureEvent.h"
#include "../../AocsEvent/ConfigurationEvent.h"
#include "../../AocsEvent/AocsEvent.h"
#include "../../OperatingSystemObjects/DummyAocsClock.h"
#include "../../FailureRecovery/NullRecoveryAction.h"

// -------------------------------------------------------------------

class TestCaseAocsEvent : public TestCase {

protected :

	FailureEventRepository failureEvtRep;
	ConfigurationEventRepository configEvtRep;

	FailureEventRepository f1;
	ConfigurationEventRepository c1;

	int size;

	DummyAocsClock aocsClock;

	AocsEvent evt;
	ConfigurationEvent configEvt;

	NullRecoveryAction nullRecAct;

public :

	TestCaseAocsEvent(int testId, char* testName):
	   TestCase(testId,testName)
	   { return; }

	virtual bool setUpTestCase();

	virtual void runTestCase()
		{ return; }
	
	virtual bool shutDownTestCase()
		{ return SHUTDOWN_SUCCESS; }

};

// -------------------------------------------------------------------

#endif