// TestCaseAocsEvent_1.cpp
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsEvent_1.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------
TestCaseAocsEvent_1::TestCaseAocsEvent_1():
	TestCaseAocsEvent(ID_AOCSEVENT*10+1,"TestCaseAocsEvent_1") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsEvent_1::runTestCase() {

	// Create dummy AocsObject
	AocsObject obj1;
	AocsObject obj2;

	// initialize event
	evt.initialize(&obj1, 1);

	// Check correct initialization of event
	if (evt.getEventType() != 1)
	{	setTestResult(TEST_FAILURE, "Incorrect event initialization");
		return;
	}
	if (evt.getTimeStamp() != 2*dummyPeriod )
	{	setTestResult(TEST_FAILURE, "Incorrect event initialization");
		return;
	}
	if (evt.getCreator() != &obj1 )
	{	setTestResult(TEST_FAILURE, "Incorrect event initialization");
		return;
	}

	// initialize configuration event
	configEvt.initialize(&obj1, 1, &obj2);

	// Check correct initialization of configuration event
	if (configEvt.getEventType() != 1)
	{	setTestResult(TEST_FAILURE, "Incorrect configuration event initialization");
		return;
	}
	if (configEvt.getTimeStamp() != 2*dummyPeriod )
	{	setTestResult(TEST_FAILURE, "Incorrect configuration event initialization");
		return;
	}
	if (configEvt.getCreator() != &obj1 )
	{	setTestResult(TEST_FAILURE, "Incorrect configuration event initialization");
		return;
	}
	if (configEvt.getLocation() != &obj2 )
	{	setTestResult(TEST_FAILURE, "Incorrect configuration event initialization");
		return;
	}

	setTestResult(TEST_SUCCESS,NULL);
	return;
}
