// TestCaseAocsEvent_2.cpp
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsEvent_2.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../AocsEvent/ConfigurationEventRepository.h"
#include "../../AocsEvent/EventTypeId.h"
#include "../../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

TestCaseAocsEvent_2::TestCaseAocsEvent_2():
	TestCaseAocsEvent(ID_AOCSEVENT*10+2,"TestCaseAocsEvent_2") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsEvent_2::runTestCase() {

	// Attempt to reset the repository size
	f1.setRepositorySize(6);

	// Check that a configuration error event was created
	ConfigurationEventRepository* configurationErrRep = 
		f1.getConfigurationEventRepository();
	AocsEvent* evt = configurationErrRep->latest();
	if (evt == NULL)
	{	setTestResult(TEST_FAILURE, "A configuration error should have been generated");
		return;
	}

	if (evt->getEventType() != MEMORY_ALREADY_ALLOCATED)
	{	setTestResult(TEST_FAILURE, "Configuration error code is wrong");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
