// TestCaseAocsEvent_4.cpp
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsEvent_4.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../AocsEvent/ConfigurationEventRepository.h"
#include "../../AocsEvent/EventTypeId.h"
#include "../../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

TestCaseAocsEvent_4::TestCaseAocsEvent_4():
	TestCaseAocsEvent(ID_AOCSEVENT*10+4,"TestCaseAocsEvent_4") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsEvent_4::runTestCase() {

	// Define auxialiry variables
	AocsEvent* evt1;
	ConfigurationEvent* evt2;

	// Add a few events to event repository
	c1.create(NULL,DUMMY_EVENT,NULL);
	c1.create(NULL,DUMMY_EVENT,NULL);
	c1.create(NULL,DUMMY_EVENT,NULL);
	c1.create(NULL,DUMMY_EVENT,NULL);
	c1.create(NULL,DUMMY_EVENT,NULL);
	c1.create(NULL,DUMMY_EVENT,NULL);
	c1.create(NULL,DUMMY_EVENT,NULL);

	// Reset repository (this should cancel the effect of the previous
	// event creation)
	c1.reset();

	// Check iteration cycle
	for (evt1=c1.latest(); !c1.isIterationEnded(); c1.previous())
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	for (evt2=c1.latestConfigurationEvent(); 
						!c1.isIterationEnded(); 
								c1.previousConfigurationEvent())
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	// Add three events and check iteration cycle
	c1.create(NULL,DUMMY_EVENT_1,NULL);
	c1.create(NULL,DUMMY_EVENT_1,NULL);
	c1.create(NULL,DUMMY_EVENT_1,NULL);

	int n=0;
	for (evt1=c1.latest(); !c1.isIterationEnded(); c1.previous())
	{	n++;
		if (evt1->getEventType() != DUMMY_EVENT_1)
		{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
			return;
		}
	}
	if (n!=3)
	{	setTestResult(TEST_FAILURE, "Wrong number of events in repository");
		return;
	}

	n = 0;
	for (evt2=c1.latestConfigurationEvent(); 
					!c1.isIterationEnded(); 
							c1.previousConfigurationEvent())
	{	n++;
		if (evt2->getEventType() != DUMMY_EVENT_1)
		{	setTestResult(TEST_FAILURE, "Wrong event type");
			return;
		}
	}

	if (n!=3)
	{	setTestResult(TEST_FAILURE, "Wrong number of events in repository");
		return;
	}

	// Saturate event repository 
	for (int i=0; i<size; i++)
		c1.create(NULL,DUMMY_EVENT_1,NULL);

	// Check iteration cycle
	n=0;
	for (evt1=c1.latest(); !c1.isIterationEnded(); c1.previous())
	{	n++;
		if (evt1->getEventType() != DUMMY_EVENT_1)
		{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
			return;
		}
	}
	if (n!=size)
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	n = 0;
	for (evt2=c1.latestConfigurationEvent(); 
					!c1.isIterationEnded(); 
							c1.previousConfigurationEvent())
	{	n++;
		if (evt2->getEventType() != DUMMY_EVENT_1)
		{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
			return;
		}
	}

	if (n!=size)
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
