// ChangeEventRepository.h
//
// Version	1.0
// Date		30.03.00
// Author	A. Pasetti
//

#ifndef ChangeEventRepositoryH
#define ChangeEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class ChangeEventRepository : public EventRepository {

	static ClassId classId;
	ChangeEvent* buffer;

public:

	ChangeEventRepository();

	void create (AocsObject* creator, 
				   EventType evtType,
					 PropertyId p, 
					   ChangeObject* c,
						 Real v);

	void setRepositorySize(int n);		// allocates memory for event buffer. This method
										// can only be called once!
	
	ChangeEvent* latestChangeEvent();		// methods to iterate through events in the repository
	ChangeEvent* previousChangeEvent();	// events are returned starting from the most recent
	
};

// -------------------------------------------------------------------
#endif