// ConfigurationEventRepository.h
//
// Version	1.0
// Date		17.01.00
// Author	A. Pasetti
//

#ifndef ConfigurationEventRepositoryH
#define ConfigurationEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class ConfigurationEventRepository : public EventRepository {

	ConfigurationEvent* buffer;

public:

	ConfigurationEventRepository();

	void create (AocsObject* creator, 
				   EventType evtType,
					 AocsObject* failureLocation);

	void setRepositorySize(int n);		// allocates memory for event buffer. This method
										// can only be called once!
	
	ConfigurationEvent* latestConfigurationEvent();	// methods to iterate through events in the repository
	ConfigurationEvent* previousConfigurationEvent();	// events are returned starting from the most recent
	
};

// -------------------------------------------------------------------
#endif