// FailureEvent.h
//
// Version	1.0
// Date		08.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for failure events
//
// -------------------------------------------------------------------

#ifndef FailureEventH
#define FailureEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/AocsEvent.h"

// -------------------------------------------------------------------

class FailureEvent : public AocsEvent {

	AocsObject* location;					// object where failure happened
	RecoveryAction* recoveryAction;			// recovery action associated to event
	static int tmImageLength[NTMFORMATS];

	void localResetConfiguration();		

public :

	FailureEvent();

	void initialize(AocsObject* creator, 
					  EventType evtType,
						AocsObject* location,
						  RecoveryAction* recoveryAction);

	AocsObject* getLocation()
		{ return location; }

	RecoveryAction* getRecoveryAction()
		{ return recoveryAction; }

	// Methods inherited from interface Configurable
	virtual void resetConfiguration();		
	virtual bool isConfigured();		

	// Methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif
