// ManoeuvreEventRepository.h
//
// Version  1.0
// Date     26.Jul.2000
// Author   T. Brown

#ifndef ManoeuvreEventRepositoryH
#define ManoeuvreEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class ManoeuvreEventRepository : public EventRepository {

	ManoeuvreEvent* buffer;

public :
	ManoeuvreEventRepository();

	// allocates memory for event buffer.
	// This method can only be called once!
	void setRepositorySize(int n);

	// create a new ManoeuvreEvent and add it to the repository
	ManoeuvreEvent* create(AocsObject* creator, EventType evtType, Manoeuvre* associatedManoeuvre);

	// methods to iterate through events in the repository
	// events are returned starting from the most recent
	// [latestManoeuvreEvent()] and working backward 
	// [previousManoeuvreEvent()]
	ManoeuvreEvent* latestManoeuvreEvent();
	ManoeuvreEvent* previousManoeuvreEvent();
};

// -------------------------------------------------------------------

#endif // ManoeuvreEventRepositoryH