// ModeEventRepository.h
//
// Version	1.0
// Date		08.02.00
// Author	A. Pasetti
//

#ifndef ModeEventRepositoryH
#define ModeEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class ModeEventRepository : public EventRepository {

	ModeEvent* buffer;

public:

	ModeEventRepository();

	void create (AocsObject* creator, 
				   EventType evtType,
					 int oldMode, 
					   int newMode,
					  	 ModeManager* modeManager);

	void setRepositorySize(int n);		// allocates memory for event buffer. This method
										// can only be called once!
	
	ModeEvent* latestModeEvent();	// methods to iterate through events in the repository
	ModeEvent* previousModeEvent();	// events are returned starting from the most recent
	
};

// -------------------------------------------------------------------
#endif