// TelecommandEvent.h
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for telecommand events
//
// -------------------------------------------------------------------

#ifndef TelecommandEventH
#define TelecommandEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/AocsEvent.h"

// -------------------------------------------------------------------

class TelecommandEvent : public AocsEvent {

	TelecommandId telecommandId;			
	static int tmImageLength[NTMFORMATS];

	void localResetConfiguration();		

public :

	TelecommandEvent();

	void initialize(AocsObject* creator, 
					  EventType evtType,
						  TelecommandId telecommandId);

	TelecommandId getTelecommandId()
		{ return telecommandId; }

	// Virtual methods inherited from interface Configurable
	virtual void resetConfiguration();		
	virtual bool isConfigured();		

	// Virtual methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif
