// TelecommandEventRepository.h
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//

#ifndef TelecommandEventRepositoryH
#define TelecommandEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class TelecommandEventRepository : public EventRepository {

	TelecommandEvent* buffer;

public:

	TelecommandEventRepository();

	void create (AocsObject* creator, 
				   EventType evtType,
					 TelecommandId telecommandId);

	// Allocate memory for event buffer. Method to be called once only!
	void setRepositorySize(int n);		
	
	// Methods to iterate through events in the repository.
	// Events are returned starting from the most recent
	TelecommandEvent* latestTelecommandEvent();		
	TelecommandEvent* previousTelecommandEvent();	
	
};

// -------------------------------------------------------------------
#endif