// ModeFactory.h
//
// Version	1.0
// Date		18.09.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Factory Class for the Operational Mode Framelet.
//
// This class should be customized (by inheritance) for each AOCS
// application.
//
// The factory produces the change mode objects that are used 
// to encapsulate actions to be taken when an old mode is exited or 
// a new mode is entered.
//
// In the present version, the only change mode object to  be 
// generated is the null mode change object that acts as a dummy and
// does nothing. Since the null mode change action has no internal
// state, only one object is created and multiple references to it
// are handed out.
//
// -------------------------------------------------------------------

#ifndef ModeFactoryH
#define ModeFactoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"

// -------------------------------------------------------------------

class ModeFactory {

	NullModeChangeAction* nullModeChangeAction;

public:

	ModeFactory();	

	ModeChangeAction* makeNullModeChangeAction();
};

#endif
