// MonitoringFactory.cpp 
//
// Version	1.0
// Date		14.09.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Factory for object monitoring framelet
// -------------------------------------------------------------------

// Include framework header files
#include "../ObjectMonitoring/SimpleChange.h"
#include "../ObjectMonitoring/DeltaChange.h"
#include "../ObjectMonitoring/OutOfRangeChange.h"

// Include the factory declaration files
#include "../AocsFactory/MonitoringFactory.h"

// Include the AOCS configuration file
#include "../AocsFactory/AocsConfiguration.h"

// -------------------------------------------------------------------

MonitoringFactory::MonitoringFactory()
{
}

// -------------------------------------------------------------------

ChangeObject* MonitoringFactory::makeSimpleChange(Real referenceValue)
{
	return new SimpleChange(referenceValue);
}

// -------------------------------------------------------------------

ChangeObject* MonitoringFactory::makeDeltaChange(Real referenceValue)
{
	return new DeltaChange(referenceValue);
}

// -------------------------------------------------------------------

ChangeObject* MonitoringFactory::makeOutOfRangeChange(
									Real lowerBound, Real higherBound)
{
	return new OutOfRangeChange(lowerBound, higherBound);
}

