// DmaTelemetryStreamOnGround.cpp
//
// Version	1.0
// Date		31.07.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include <string.h>

#include "DmaTelemetryStreamOnGround.h"

// -------------------------------------------------------------------

void DmaTelemetryStreamOnGround::reset(char* buffer, int size)
{
	dmaBuffer = buffer;
	bufferSize = size;

	nextByte=5;
	nextBit=0;
}

// -------------------------------------------------------------------

char DmaTelemetryStreamOnGround::readChar()
{
	char c = dmaBuffer[nextByte];
	nextByte++;
	return c;
}

// -------------------------------------------------------------------

unsigned char DmaTelemetryStreamOnGround::readUnsignedChar()
{
	unsigned char c = dmaBuffer[nextByte];
	nextByte++;
	return c;
}

// -------------------------------------------------------------------

float DmaTelemetryStreamOnGround::readFloat()
{
	float d;
	memcpy(&d, dmaBuffer+nextByte, 4);
	nextByte+=4;
	return d;
}

// -------------------------------------------------------------------

int DmaTelemetryStreamOnGround::readInt()
{
	int d;
	memcpy(&d, dmaBuffer+nextByte, 4);
	nextByte+=4;
	return d;
}

// -------------------------------------------------------------------

unsigned int DmaTelemetryStreamOnGround::readUnsignedInt()
{
	unsigned int d;
	memcpy(&d, dmaBuffer+nextByte, 4);
	nextByte+=4;
	return d;
}

// -------------------------------------------------------------------

short DmaTelemetryStreamOnGround::readShort()
{
	short d;
	memcpy(&d, dmaBuffer+nextByte, 2);
	nextByte+=2;
	return d;
}

// -------------------------------------------------------------------

unsigned short DmaTelemetryStreamOnGround::readUnsignedShort()
{
	unsigned short d;
	memcpy(&d, dmaBuffer+nextByte, 2);
	nextByte+=2;
	return d;
}


