// FollowerUnitTriggerModeManager.cpp
//
// Version	1.0
// Date		02.06.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../AocsUnit/FollowerUnitTriggerModeManager.h"
#include "../AocsUnit/TriggerList.h"

// -------------------------------------------------------------------

FollowerUnitTriggerModeManager::FollowerUnitTriggerModeManager
		(int m,int n,ModeManager* s):FollowerModeManager(m,1,n,s)
{
	setClassId(ID_FOLLOWERUNITTRIGGERMODEMANAGER);	
	oldTriggerList = NULL;
}

// -------------------------------------------------------------------

void FollowerUnitTriggerModeManager::loadTriggerList
		(int mode, TriggerList* t)
{
	loadImplementer(mode,0,(RootObject*)t);
}

// -------------------------------------------------------------------
// Upon a mode transition, old unit lists that are switched out are 
// shutdown. New unit lists that are switched in are initialized.

TriggerList* FollowerUnitTriggerModeManager::getTriggerList()
{ 
	if (oldTriggerList == NULL)		// first cycle
	{
		oldTriggerList = (TriggerList*)getImplementer(0);
		oldTriggerList->initialize();
		return oldTriggerList;
	}

	if (oldTriggerList != (TriggerList*)getImplementer(0))
	{
		oldTriggerList->shutdown();
		oldTriggerList = (TriggerList*)getImplementer(0);
		oldTriggerList->initialize();
	}
	return oldTriggerList;
}