// FollowerUnitTriggerModeManager.h
//
// Version	1.0
// Date		02.06.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for the follower unit trigger mode manager.
// This mode manager is built on the follower mode manager.
// -------------------------------------------------------------------

#ifndef FollowerUnitTriggerModeManagerH
#define FollowerUnitTriggerModeManagerH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ModeManagement/FollowerModeManager.h"
#include "../AocsUnit/UnitTriggerModeManager.h"

// -------------------------------------------------------------------

class FollowerUnitTriggerModeManager : public FollowerModeManager,
											public UnitTriggerModeManager {

	TriggerList* oldTriggerList;

public :

	// Constructor
	FollowerUnitTriggerModeManager( int numberOfModes, 
				 					 int maxNumberOfMonitors,
									  ModeManager* masterModeManager );

	// Configuration method to load the implementers
	virtual void loadTriggerList(int mode, TriggerList* t);

	// Strategy getter methods
	virtual TriggerList* getTriggerList();
};

// -------------------------------------------------------------------
#endif
