// GyrPrototype.h
//
// Version	1.0
// Date		31.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for the AOCS prototype encapsulating a single one-axis gyro.
//
// Two MACS instructions can be sent to the gyro: an initialization RC
// and a TI to acquire the gyro read-out. The gyro read-out represents
// the angular rate around the gyro sensing axis.
// -------------------------------------------------------------------

#ifndef GyrPrototypeH
#define GyrPrototypeH

// -------------------------------------------------------------------

#include "../AocsUnit/AocsUnit.h"

// -------------------------------------------------------------------

class GyrPrototype : public AocsUnit {

	unsigned short address;
	unsigned short angle;

public:

	GyrPrototype(unsigned short address,
					unsigned short angle);

	virtual void initialize();

	virtual void acquireFunctionalData();
};

// -------------------------------------------------------------------
#endif