// TestCaseAocsObject_1.cpp
//
// Version	1.0
// Date		06.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsObject_1.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------
TestCaseAocsObject_1::TestCaseAocsObject_1():
	TestCaseAocsObject(ID_AOCSOBJECT*10+1,"TestCaseAocsObject_1") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsObject_1::runTestCase() {

	int val;

	a1.setTelemetryFormat(shortTm);
	val = a1.getTelemetryImageLength();
	if (val!=24)
	{	setTestResult(TEST_FAILURE, "Incorrect TM image length - shortTm format");
		return;
	}
	
	a1.setTelemetryFormat(normalTm);
	val = a1.getTelemetryImageLength();
	if (val!=24)
	{	setTestResult(TEST_FAILURE, "Incorrect TM image length - normalTm format");
		return;
	}
	
	a1.setTelemetryFormat(longTm);
	val = a1.getTelemetryImageLength();
	if (val!=24)
	{	setTestResult(TEST_FAILURE, "Incorrect TM image length - longTm format");
		return;
	}

	a1.setTelemetryFormat(debugTm);
	val = a1.getTelemetryImageLength();
	if (val!=72)
	{	setTestResult(TEST_FAILURE, "Incorrect TM image length - debugTm format");
		return;
	}

	setTestResult(TEST_SUCCESS,NULL);
	return;
}
