// TestCaseRootObject.h
//
// Version	1.0
// Date		12.12.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Abstract base class for test cases for class RootObject.
// This is a trivial class that simply exists to provide three
// instances of class RootObjects. These three objects are 
// used by concrete test cases encapsulated in subclasses of
// TestCaseRootObject.
//
// -------------------------------------------------------------------

#ifndef TestCaseRootObjectH
#define TestCaseRootObjectH

#include "../../GeneralUtilities/TestCase.h"
#include "../RootObject.h"

// -------------------------------------------------------------------

class TestCaseRootObject : public TestCase {

protected :
	
	RootObject r1, r2, r3;

public :

	TestCaseRootObject(int testId, char* testName):
	   TestCase(testId,testName)
	   { return; }

	virtual bool setUpTestCase()
		{ return INITIALIZATION_SUCCESS; }

	virtual void runTestCase()
		{ return; }
	
	virtual bool shutDownTestCase()
		{ return SHUTDOWN_SUCCESS; }

};

// -------------------------------------------------------------------

#endif
