// ControllerManager.h
//
// Version  1.0
// Date     03.11.2000
// Author   T. Brown
//
// -------------------------------------------------------------------
// Controller manager class
// -------------------------------------------------------------------

#ifndef ControllerManagerH
#define ControllerManagerH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../BasicObjects/AocsObject.h"
#include "../OperatingSystemObjects/Runnable.h"

// -------------------------------------------------------------------

class ControllerManager : public AocsObject, public Runnable {

    static int tmImageLength[NTMFORMATS];

    // List of Controllers to be used
    //ObjectListTemplate<Controller>* controllerList;

    // Mode manager to supply controller list
    ControllerModeManager* modeManager;

    // Local reset configuration method
    void localResetConfiguration();

public:

    // Constructor
    ControllerManager();

    // Scheduler entry point
    virtual void run(AocsTime deadline);

    // pure virtual methods from Configurable
    virtual void resetConfiguration();
    virtual bool isConfigured();

    // Virtual methods inherited from interface Telemeterable
    virtual void writeToTelemetry(TelemetryStream* stream);
    virtual int getTelemetryImageLength();

    // get and set mode manager
    void setModeManager(ControllerModeManager* cmm);
    ControllerModeManager* getModeManager();
};

// -------------------------------------------------------------------
#endif // ControllerManagerH