// FollowerControllerModeManager.cpp
//
// Version  1.0
// Date     04.11.2000
// Author   T. Brown/A. Pasetti
//
// -------------------------------------------------------------------

#include "../GeneralInclude/ClassId.h"
#include "../ControllerManagement/Controller.h"
#include "../ControllerManagement/FollowerControllerModeManager.h"
#include "../ObjectList/ObjectListTemplate.h"

// -------------------------------------------------------------------
FollowerControllerModeManager::FollowerControllerModeManager
    (int m, int n, ModeManager* s) : FollowerModeManager(m, 1, n, s)
{
    setClassId(ID_FOLLOWERCONTROLLERMODEMANAGER);
	oldControllerList = NULL;
}

// -------------------------------------------------------------------
void FollowerControllerModeManager::loadControllerList
        (int mode, ObjectListTemplate<Controller>* controllerList)
{
    loadImplementer(mode,0,(RootObject*)controllerList);
}

// -------------------------------------------------------------------
// When a new controller is switched in, it must be reset

ObjectListTemplate<Controller>* FollowerControllerModeManager::getControllerList()
{
	if (oldControllerList == NULL)		// first activation
		oldControllerList = (ObjectListTemplate<Controller>*)getImplementer(0);
	
	if (oldControllerList!=(ObjectListTemplate<Controller>*)getImplementer(0))
    {
		ObjectListTemplate<Controller>* newControllerList = 
					(ObjectListTemplate<Controller>*)getImplementer(0);
		Controller* c;
		for (c = newControllerList->first();
				!newControllerList->isLast();
					c = newControllerList->next())
			if (c != (Controller*)oldControllerList->getObjectByPosition(
											newControllerList->getPosition()))
				c->reset();

		oldControllerList = newControllerList;
	}

	return oldControllerList;
}
