// FollowerFailureDetectionModeManager.cpp
//
// Version	1.0
// Date		08.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../FailureDetection/FollowerFailureDetectionModeManager.h"
#include "../GeneralInclude/ClassId.h"
#include "../FailureDetection/MonitoringCheck.h"

// -------------------------------------------------------------------

FollowerFailureDetectionModeManager::FollowerFailureDetectionModeManager
		(int m,int n,ModeManager* s):FollowerModeManager(m,2,n,s)
{
	setClassId(ID_FOLLOWERFAILUREDETECTIONMODEMANAGER);	
	oldMonitoringCheckList=NULL;
}

// -------------------------------------------------------------------

void FollowerFailureDetectionModeManager::loadConsistencyCheckableList
		(int mode, ObjectListTemplate<ConsistencyCheckable>* l)
{
	loadImplementer(mode,0,(RootObject*)l);
}

// -------------------------------------------------------------------

void FollowerFailureDetectionModeManager::loadMonitoringCheckList
		(int mode, ObjectListTemplate<MonitoringCheck>* l)
{
	loadImplementer(mode,1,(RootObject*)l);
}

// -------------------------------------------------------------------

ObjectListTemplate<ConsistencyCheckable>* 
		FollowerFailureDetectionModeManager::getConsistencyCheckableList()
{ 
	return (ObjectListTemplate<ConsistencyCheckable>*)getImplementer(0);
}

// -------------------------------------------------------------------
// If the active MonitoringCheckList has changed, then all its change
// objects must be reset

ObjectListTemplate<MonitoringCheck>* 
		FollowerFailureDetectionModeManager::getMonitoringCheckList()
{ 
	if (oldMonitoringCheckList!=(ObjectListTemplate<MonitoringCheck>*)getImplementer(1))
	{	oldMonitoringCheckList=(ObjectListTemplate<MonitoringCheck>*)getImplementer(1);
		MonitoringCheck* m;
		for ( m=oldMonitoringCheckList->first(); 
				!oldMonitoringCheckList->isLast(); 
				   m=oldMonitoringCheckList->next() )
			m->getChangeObject()->reset();
	}
		
	return oldMonitoringCheckList;
}
