// MonitoringCheck.h 
//
// Version	1.0
// Date		05.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Encapsulation of a monitoring check
//
// -------------------------------------------------------------------

#ifndef MonitoringCheckH
#define MonitoringCheckH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../BasicObjects/AocsObject.h"
#include "../ObjectMonitoring/Property.h"

// -------------------------------------------------------------------

class MonitoringCheck : public AocsObject {

	static int tmImageLength[NTMFORMATS];

	Property monitoredProperty;
	ChangeObject* changeObject;
	RecoveryAction* recoveryAction;

public :

	MonitoringCheck(Property monitoredProperty, 
					  ChangeObject* changeObject,
						RecoveryAction* recoveryAction);

	// Straightforward getter methods
	Real getPropertyValue()
		{ return monitoredProperty.get(); }

	Property getProperty()
		{ return monitoredProperty; }

	ChangeObject* getChangeObject()
		{ return changeObject; }

	RecoveryAction* getRecoveryAction()
		{ return recoveryAction; }

	// Methods inherited from Telemeterable interface
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();

};

// -------------------------------------------------------------------
#endif