// FollowerFailureRecoveryModeManager.cpp
//
// Version	1.0
// Date		08.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../FailureRecovery/FollowerFailureRecoveryModeManager.h"
#include "../GeneralInclude/ClassId.h"
#include "../FailureRecovery/RecoveryStrategy.h"

// -------------------------------------------------------------------

FollowerFailureRecoveryModeManager::FollowerFailureRecoveryModeManager
		(int m,int n,ModeManager* s):FollowerModeManager(m,1,n,s)
{
	setClassId(ID_FOLLOWERFAILURERECOVERYMODEMANAGER);	
}

// -------------------------------------------------------------------

void FollowerFailureRecoveryModeManager::loadRecoveryStrategy
		(int mode, RecoveryStrategy* l)
{
	loadImplementer(mode,0,(RootObject*)l);
}

// -------------------------------------------------------------------

RecoveryStrategy* FollowerFailureRecoveryModeManager::getRecoveryStrategy()
{ 
	if ( (RecoveryStrategy*)getImplementer(0) != oldRecoveryStrategy )
	{	oldRecoveryStrategy = (RecoveryStrategy*)getImplementer(0);
		oldRecoveryStrategy->reset();
	}

	return oldRecoveryStrategy;
}

