// FollowerFailureRecoveryModeManager.h
//
// Version	1.0
// Date		12.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for the follower failure recovery mode manager.
// This mode manager is built on the follower mode manager.
// Newly loaded recovery strategies are reset.
// -------------------------------------------------------------------

#ifndef FollowerFailureRecoveryModeManagerH
#define FollowerFailureRecoveryModeManagerH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ModeManagement/FollowerModeManager.h"
#include "../FailureRecovery/FailureRecoveryModeManager.h"

// -------------------------------------------------------------------

class FollowerFailureRecoveryModeManager : public FollowerModeManager,
											public FailureRecoveryModeManager {

	RecoveryStrategy* oldRecoveryStrategy;

public :

	// Constructor
	FollowerFailureRecoveryModeManager( int numberOfModes, 
				 						 int maxNumberOfMonitors,
										  ModeManager* masterModeManager );

	// Configuration method to load the implementers
	virtual void loadRecoveryStrategy(int mode, RecoveryStrategy* r);

	// Strategy getter methods
	virtual RecoveryStrategy* getRecoveryStrategy();
};

// -------------------------------------------------------------------
#endif
