// LocalRecoveryActions.h
//
// Version	1.0
// Date		10.05.00
// Author	A. Pasetti

#ifndef LocalRecoveryActionsH
#define LocalRecoveryActionsH

// -------------------------------------------------------------------
// Recovery strategy that executes the recovery actions associated to 
// all the failure events generated since the last activation.
// -------------------------------------------------------------------

#include "../FailureRecovery/RecoveryStrategy.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"

// -------------------------------------------------------------------

class LocalRecoveryActions : public RecoveryStrategy {

	static int tmImageLength[NTMFORMATS];

	int lastEventCounter;

	void localReset();

public :

	LocalRecoveryActions();

	virtual void doRecovery();

	// Virtual methods inherited from interface Resettable
	virtual void reset();		

	// Virtual methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();

};

// -------------------------------------------------------------------
#endif