// ModeChange.cpp
//
// Version	1.0
// Date		10.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../FailureRecovery/ModeChange.h"
#include "../FailureRecovery/RecoveryAction.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../ModeManagement/ModeManager.h"

// -------------------------------------------------------------------

ModeChange::ModeChange(ModeManager* m, int n)
{
	setClassId(ID_MODECHANGE);		

	modeManager = m;
	newMode = n;

}

// -------------------------------------------------------------------

void ModeChange::doRecovery()
{
	if ( isEnabled() )
		modeManager->setMode(newMode);

	RecoveryAction::doRecovery();
}	
	
