// ObjectReset.cpp
//
// Version	1.0
// Date		10.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../FailureRecovery/ObjectReset.h"
#include "../FailureRecovery/RecoveryAction.h"
#include "../GeneralInclude/ClassId.h"
#include "../BasicObjects/Resettable.h"

// -------------------------------------------------------------------

ObjectReset::ObjectReset(AocsObject* r)
{
	setClassId(ID_SYSTEMRESET);		

	objectToBeReset = r;
}

// -------------------------------------------------------------------

void ObjectReset::doRecovery()
{
	if ( isEnabled() )
		objectToBeReset->reset();

	RecoveryAction::doRecovery();
}	
	
