// Reconfiguration.cpp
//
// Version	1.0
// Date		10.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../FailureRecovery/Reconfiguration.h"
#include "../FailureRecovery/RecoveryAction.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../ReconfigurationManagement/Reconfigurable.h"

// -------------------------------------------------------------------

Reconfiguration::Reconfiguration(Reconfigurable* r)
{
	setClassId(ID_RECONFIGURATION);	

	objectToBeReconfigured = r;
}

// -------------------------------------------------------------------

void Reconfiguration::doRecovery()
{
	if ( isEnabled() )
		if ( objectToBeReconfigured->canReconfigure() )
			objectToBeReconfigured->reconfigure();
		else
			if (getNextRecoveryAction() != NULL)
				getNextRecoveryAction()->doRecovery();
}	
	
