// SystemResetOnConfigurationError.cpp
//
// Version	1.0
// Date		28.07.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../FailureRecovery/SystemResetOnConfigurationError.h"
#include "../FailureRecovery/RecoveryStrategy.h"
#include "../SystemManagement/SystemManager.h"
#include "../AocsEvent/FailureEventRepository.h"
#include "../AocsEvent/RecoveryEventRepository.h"
#include "../AocsEvent/EventTypeId.h"
#include "../AocsEvent/ConfigurationEventRepository.h"

// -------------------------------------------------------------------

SystemResetOnConfigurationError::SystemResetOnConfigurationError()
{
	setClassId(ID_SYSTEMRESETONCONFIGURATIONERROR);		

}

// -------------------------------------------------------------------

void SystemResetOnConfigurationError::doRecovery()
{
	if (!isEnabled())
	{	RecoveryStrategy::doRecovery();
		return;
	}

	if ( AocsObject::getConfigurationEventRepository()->getCounter() > 0 )
	{	AocsObject::getSystemManager()->systemReset();
		RecoveryStrategy::getRecoveryEventRepository()->
			create(this,SYSTEM_RESET_RECOVERY,(RecoveryAction*)NULL,this);
	}
	else
	{	RecoveryStrategy::doRecovery();
		return;
	}
}	
	
