// TestSuite.cpp
//
// Version	1.0
// Date		20.12.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestSuite.h"
#include "TestCase.h"
#include "../GeneralUtilities/TestUtilities.h"
#include <string.h>

// -------------------------------------------------------------------

TestSuite::TestSuite(FILE* outputFile) {

	out = outputFile;
	testCaseCounter = 0;
}

// -------------------------------------------------------------------

void TestSuite::runTestSuite() {

	for (int i=0; i<testCaseCounter; i++)
	{
		if (!list[i]->setUpTestCase())
		{	printString(out,"Initialization for test ");
			printString(out,list[i]->getTestName());
			printString(out," failed ...\n");
		}	
			
		list[i]->runTestCase();

		if (!list[i]->shutDownTestCase())
		{	printString(out,"Shut down for test ");
			printString(out,list[i]->getTestName());
			printString(out," failed ...\n");
		}	

		if (list[i]->getTestOutcome())
			printTestSuccess(out,list[i]->getTestName());
		else
		{	printTestFailed(out,list[i]->getTestName());
			if (list[i]->getFailureMessage()!=NULL)
				printMessage(out,list[i]->getFailureMessage());
		}
	}
}

// -------------------------------------------------------------------

void TestSuite::loadTestCase(TestCase* newTestCase) {

	if (testCaseCounter<MAX_TEST_CASES_IN_SUITE)
	{	
		list[testCaseCounter] = newTestCase;
		testCaseCounter++;
	}
}
