// TestUtilities.h 
//
// Version	1.0
// Date		17.01.00
// Author	A. Pasetti
// -------------------------------------------------------------------

#include <stdio.h>
#include <time.h>
#include "../GeneralInclude/Include.h"

// -------------------------------------------------------------------

void printTestHeader(FILE* outFile, char* testName)
{
#ifdef MS_HOST
	fprintf(outFile,"Running test %s ...\n",testName);
#else
	printf("Running test %s ...\n",testName);
#endif

	// retrieve current time (only if running on MS host)
#ifdef MS_HOST
	time_t ltime;
    time( &ltime );
	fprintf(outFile,"Test run performed on: %s\n", ctime( &ltime ));
#endif
}

// -------------------------------------------------------------------

void printTestSuccess(FILE* outFile, char* testName)
{
#ifdef MS_HOST
	fprintf(outFile,"Test %s executed successfully ...\n",testName);
#else
	printf("Test %s executed successfully ...\n",testName);
#endif
}

// -------------------------------------------------------------------

void printTestFailed(FILE* outFile, char* testName)
{
#ifdef MS_HOST
	fprintf(outFile,"Test %s failed ...\n",testName);
#else
	printf("Test %s failed ...\n",testName);
#endif
}

// -------------------------------------------------------------------

void printTestResult(FILE* outFile, char* testName, char* msg, double value)
{
#ifdef MS_HOST
	fprintf(outFile,"Test: %s, %s %f\n", testName, msg, value);
#else
	printf("Test: %s, %s %f\n", testName, msg, value);
#endif
}

// -------------------------------------------------------------------

void printTestOutcome(FILE* outFile, char* testName, bool outcome)
{
	if (outcome)
		printTestSuccess(outFile, testName);
	else
		printTestFailed(outFile, testName);
}

// -------------------------------------------------------------------

void printByte(FILE* outFile, char byte)
{
#ifdef MS_HOST
	fprintf(outFile,"%2x ",byte);
#else
	printf("%2x ",byte);
#endif
}

// -------------------------------------------------------------------

void printInt(FILE* outFile, int n)
{
#ifdef MS_HOST
	fprintf(outFile,"%d ",n);
#else
	printf("%d ",n);
#endif
}

// -------------------------------------------------------------------

void printDouble(FILE* outFile, double f)
{
#ifdef MS_HOST
	fprintf(outFile,"%.5f ",f);
#else
	printf("%.5f ",f);
#endif
}

// -------------------------------------------------------------------

void printMessage(FILE* outFile, char* msg)
{
#ifdef MS_HOST
	fprintf(outFile,"%s \n",msg);
#else
	printf("%s \n",msg);
#endif
}

// -------------------------------------------------------------------

void printMessage(FILE* outFile, char* msg, int n)
{
#ifdef MS_HOST
	fprintf(outFile,"%s \n",msg);
#else
	printf("%s ",msg);
#endif
}

// -------------------------------------------------------------------

void printString(FILE* outFile, char* msg)
{
#ifdef MS_HOST
	fprintf(outFile,"%s",msg);
#else
	printf("%s",msg);
#endif
}

// -------------------------------------------------------------------

void printWord(FILE* outFile, unsigned short word)
{
#ifdef MS_HOST
	fprintf(outFile,"%4x ",word);
#else
	printf("%4x ",word);
#endif
}

