// TestUtilities.h 
//
// Version	1.0
// Date		17.01.00
// Author	A. Pasetti
// -------------------------------------------------------------------

#include <stdio.h>  

// -------------------------------------------------------------------

// Print header message to file 'outFile' for test 'testName'
void printTestHeader(FILE* outFile, char* testName); 

// -------------------------------------------------------------------
// Print message to file 'outFile' upon successful execution of test 'testName'
void printTestSuccess(FILE* outFile, char* testName); 

// -------------------------------------------------------------------
// Print message to file 'outFile' upon failed execution of test 'testName'
void printTestFailed(FILE* outFile, char* testName); 

// -------------------------------------------------------------------
// Print result of test 'testName' to file 'outFile' with explanation 'msg'
void printTestResult(FILE* outFile, char* testName, char* msg, double value);

// -------------------------------------------------------------------
// If 'result' is true, print success message for test 'testName' to file 
// 'outFile'. If 'result' is not true, then pring a failure message
void printTestOutcome(FILE* outFile, char* testName, bool outcome);

// -------------------------------------------------------------------
// Print a byte as an hex to file 'outFile' 
void printByte(FILE* outFile, char byte);

// -------------------------------------------------------------------
// Print a word as an hex to file 'outFile' 
void printWord(FILE* outFile, unsigned short byte);

// -------------------------------------------------------------------
// Print an integer to file 'outFile' 
void printInt(FILE* outFile, int n);

// -------------------------------------------------------------------
// Print a float to file 'outFile' 
void printDouble(FILE* outFile, double f);

// -------------------------------------------------------------------
// Print a message to file 'outFile' 
void printMessage(FILE* outFile, char* msg);

// -------------------------------------------------------------------
// Print a message to file 'outFile' 
void printString(FILE* outFile, char* msg);
