// DummyManoeuvre.cpp
//
// Version	1.0
// Date		09 Aug 2000
// Author	T. Brown/A. Pasetti
//
// Change Record:
//	AP, 15.08.00: commented all fprintf statements. They can be 
//		automatically reinstated by replacing string "// fprintf" 
//		with string "fprint"
// -------------------------------------------------------------------

// Include system header files
#include "../ManoeuvreManagement/DummyManoeuvre.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------
void DummyManoeuvre::setup(int steps, char* n, FILE* o)
{
	stepsToTake = steps;
	name = n;
	out = o;
}

// -------------------------------------------------------------------
DummyManoeuvre::DummyManoeuvre(AocsTime t, int steps) 
	: Manoeuvre()
{
	setClassId(ID_DUMMY_MANOEUVRE);	
	setup(steps, "noname", NULL);
	Manoeuvre::setTimeTag(t);
}

// -------------------------------------------------------------------
DummyManoeuvre::DummyManoeuvre(AocsTime t, int steps, char* n, FILE* o) 
	: Manoeuvre()
{
	setClassId(ID_DUMMY_MANOEUVRE);
	setup(steps, n, o);
	Manoeuvre::setTimeTag(t);
}

// -------------------------------------------------------------------
void DummyManoeuvre::initialize() 
{
	Manoeuvre::initialize();
	currentStep = 0;
	if (out != NULL)
	{
		// fprintf(out,"\tDummyManoeuvre %s " "(at address %p) " "has been initialized\n",name, this);
	}
}

// -------------------------------------------------------------------
void DummyManoeuvre::doContinue() {
	if (currentState == inProcess)
	{
		currentStep++;
		if (out != NULL) 
		{
			// fprintf(out,"\tDummyManoeuvre %s " "(at address %p) " "has taken step %d\n", name, this, currentStep);
		}

		if (currentStep >= stepsToTake) 
		{
			currentState = finished;
			notifyMonitors(currentState);
			if (out != NULL)
			{
				// fprintf(out,"\tDummyManoeuvre %s ""(at address %p) ""is finished\n",name, this);
			}
		}
	}
}

// -------------------------------------------------------------------
