// DummyManoeuvre.h
//
// Version	1.0
// Date		09 Aug 2000
// Author	T. Brown
//
// -------------------------------------------------------------------

#ifndef DummyManoeuvreH
#define DummyManoeuvreH

// -------------------------------------------------------------------

#include <stdio.h>

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../ManoeuvreManagement/Manoeuvre.h"

// -------------------------------------------------------------------

class DummyManoeuvre : public Manoeuvre {

	// These are dummy attributes for implementation of a trivial
	// behavior.
	int currentStep;
	int stepsToTake;
	FILE* out;
	char* name;
	
	// setup a DummyManoeuvre
	// @param	steps	number of steps to take
	// @param   n		name of this manoeuvre
	// @param	o		where to write output indicating steps taken
	void setup(int steps, char* n, FILE* o);

public :

	// create a DummyManoeuvre
	// @param	t	time after which this DummyManoeuvre should
	//              be considered for execution
	// @param  steps  number of steps to take
	DummyManoeuvre(AocsTime t, int steps);

	// create a DummyManoeuvre
	// @param	t		time after which this DummyManoeuvre should 
	//					be considered for execution
	// @param	steps	number of steps to take
	// @param   n		name of this manoeuvre
	// @param	o		where to write output indicating steps taken
	DummyManoeuvre(AocsTime t, int steps, char* n, FILE* o);

	// Overriden methods from the Manoeuvre class
	virtual void initialize();
	virtual void doContinue();

};

// -------------------------------------------------------------------
#endif // DummyManoeuvreH
