// TestCaseManoeuvre_2.cpp
//
// Version	1.0
// Date		06.02.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseManoeuvre_2.h"
#include "ManoeuvreManagementTestSuite.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsEvent/ConfigurationEvent.h"
#include "../../AocsEvent/EventTypeId.h"
#include "../../ManoeuvreManagement/ManoeuvreManager.h"

// -------------------------------------------------------------------
TestCaseManoeuvre_2::TestCaseManoeuvre_2():
	TestCaseGenericSetUp(ID_MANOEUVREMANAGER*10+2,
									"TestCaseManoeuvre_2") {
		return;
}

// -------------------------------------------------------------------

void TestCaseManoeuvre_2::runTestCase() {

    // Create a ManoeuvreManager
    ManoeuvreManager mnManager;

    // Initialize the ManoeuvreManager's list size.
    mnManager.initializeManoeuvreList(20);

    // Verify that a configuration error event was generated with the
    // proper attributes
    ConfigurationEvent* ce =
        mnManager.getConfigurationEventRepository()->latestConfigurationEvent();

    // Check that the manoeuvre manager is configured
    if (!mnManager.isConfigured())
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 2 failed");
		return;
	}

    // Try to double call the initialization method
    mnManager.initializeManoeuvreList(20);

    // Verify that this failed with the proper configuration event
    ConfigurationEvent* ce2 = mnManager.getConfigurationEventRepository()->
                                                latestConfigurationEvent();
    bool properConfigEvt =
        verifyLatestConfigurationEvent( ce2,
            AocsObject::getAocsClock()->getTime(), MEMORY_ALREADY_ALLOCATED,
            &mnManager, &mnManager);

    if (!properConfigEvt)
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 2 failed");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}


