// MemoryTest.cpp 
//
// Version	1.0
// Date		20.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for measuring the memory footprint of the framework 
// classes on the ERC32 host.
// The test program does nothing. It is meant to be linked with varying
// numbers of framework classes to measure the changes in memory
// occupation of the executable.
// -------------------------------------------------------------------

#include <stdio.h>

// Include framework header files
#include "../GeneralInclude/Include.h"
#include "../TelemetryManagement/Telemeterable.h"
#include "../BasicObjects/Include.h"
#include "../OperatingSystemObjects/Runnable.h"
#include "../OperatingSystemObjects/AocsClock.h"
#include "../FailureDetection/ConsistencyCheckable.h"
#include "../AocsEvent/Include.h"
#include "../ObjectList/Include.h"
#include "../AocsData/Include.h"
#include "../FailureRecovery/RecoveryAction.h"
#include "../FailureRecovery/NullRecoveryAction.h"
#include "../Xmath/Include.h"
#include "../SequentialDataProcessing/Include.h"

// Include test header files
#include "../BasicObjects/DummyAocsObject.h"
#include "../OperatingSystemObjects/DummyAocsClock.h"
#include "../GeneralUtilities/TestUtilities.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open outut file 
	FILE* out;
    if( (out  = fopen("memoryTestOut.txt","w")) == NULL )
      printf( "\nThe file 'memoryTestOut.txt' could not be opened\n" );   
	else
      printf( "\nThe file 'memoryTestOut.txt' was successfully opened\n" );
	
	// Print header message to output file
	printTestHeader(out,"MemoryTest");

	// Print dummy messages
    printf( "\nMemory test - no action ...\n" );

	// close output file
	fclose(out);
	return 0;
}
