// AocsMissionModeManager.h
//
// Version	1.0
// Date		01.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for the AOCS mission mode manager
//
// -------------------------------------------------------------------

#ifndef AocsMissionModeManagerH
#define AocsMissionModeManagerH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ModeManagement/ModeManager.h"
#include "../GeneralInclude/ClassId.h"

// -------------------------------------------------------------------

class AocsMissionModeManager : public ModeManager {

public :

	AocsMissionModeManager(int nOfModes,int defaultMode,int nOfMonitors):
		ModeManager(nOfModes,1,defaultMode,nOfMonitors)
			{ setClassId(ID_AOCSMISSIONMODEMODEMANAGER); }

	// The AOCS mission mode manager has no implementers
	void loadImplementer(int mode, int strategy, RootObject* implementer)
		{ return; }

	// The AOCS mission mode manager has no implementers
	virtual RootObject* getImplementer(int strategy)
		{ return 0; }

	// The AOCS mission mode manager has no configuration
	virtual bool isConfigured()
		{ return true; }

};

// -------------------------------------------------------------------
#endif
