// CyclingModeManager.h
//
// Version	1.0
// Date		04.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for the cycling mode manager (the mode manager cycles through
// its mode changing mode every time operation getImplementer is called)
//
// -------------------------------------------------------------------

#ifndef CyclingModeManagerH
#define CyclingModeManagerH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ModeManagement/ModeManager.h"

// -------------------------------------------------------------------

class CyclingModeManager : public ModeManager {

protected :

	// Update the current mode
	virtual void updateMode();

public :

	// Constructor
	CyclingModeManager(int numberOfModes, 
						int defaultMode,
						 int maxNumberOfMonitors);

	// Strategy getter method
	virtual RootObject* getImplementer(int strategy);

};

// -------------------------------------------------------------------
#endif
