// ObjectListTemplate.h
//
// Version	1.0
// Date		14.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Template wrapper for object lists
//
// This class uses the methods of the base class ObjectList to implement
// list operations. It adds downcasts to let the user deal with specific
// types rather than with the generic RootObject type.
//
// -------------------------------------------------------------------

#ifndef ObjectListTemplateH
#define ObjectListTemplateH

// -------------------------------------------------------------------

#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ObjectList/ObjectList.h"

// -------------------------------------------------------------------

template <class ObjectType> class ObjectListTemplate: public ObjectList {

public :

	ObjectListTemplate()
		{ setClassId(ID_OBJECTLISTTEMPLATE); }
	
	int addObject(ObjectType* newObject)
		{ return ObjectList::addObject((void*)newObject); }

	int removeObject(ObjectType* object)
		{ return ObjectList::removeObject((void*)object); }

	ObjectType* first()
		{ return (ObjectType*)ObjectList::first(); }

	ObjectType* next()
		{ return (ObjectType*)ObjectList::next(); }

};

// -------------------------------------------------------------------
#endif
