// TestCaseObjectList_1.cpp
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseObjectList_1.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../BasicObjects/AocsObject.h"
#include "../../ObjectList/ObjectListTemplate.h"
#include "../../AocsEvent/EventTypeId.h"
#include "../../AocsEvent/ConfigurationEvent.h"

// -------------------------------------------------------------------
TestCaseObjectList_1::TestCaseObjectList_1():
	TestCaseObjectList(ID_OBJECTLIST*10+1,"TestCaseObjectList_1") {
		return;
}

// -------------------------------------------------------------------

void TestCaseObjectList_1::runTestCase() {

	// Check that object list is configured
	if ( !(objectList.isConfigured()) )
	{	setTestResult(TEST_FAILURE, "Object list is not configured");
		return;
	}

	// Check correct list size
	if ( objectList.getListSize() != size )
	{	setTestResult(TEST_FAILURE, "Incorrect object list size");
		return;
	}

	// Attempt to allocate memory a second time
	objectList.allocateMemory(2*size);

	// Check that list size has not changed
	if ( objectList.getListSize() != size )
	{	setTestResult(TEST_FAILURE, "Incorrect configuration of object list");
		return;
	}

	// Check that configuration event was generated
	if (AocsObject::getConfigurationEventRepository()->latestConfigurationEvent()
			->getEventType() != MEMORY_ALREADY_ALLOCATED )
	{	setTestResult(TEST_FAILURE, "Incorrect event generation");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
