// OutOfRangeChange.cpp
//
// Version	1.0
// Date		29.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../ObjectMonitoring/OutOfRangeChange.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------
// Define static variables
int OutOfRangeChange::tmImageLength[NTMFORMATS];

// -------------------------------------------------------------------

OutOfRangeChange::OutOfRangeChange(Real l, Real h)
{
	setClassId(ID_OUTOFRANGECHANGE);			// assign class identifier

	tmImageLength[shortTm]  = 0;	
	tmImageLength[normalTm] = 2*sizeof(Real);
	tmImageLength[longTm]   = tmImageLength[normalTm] + sizeof(Real) ;
	tmImageLength[debugTm]  = tmImageLength[longTm] ;

	
	upperBound = h;
	lowerBound = l;
	referenceValue = h;

}

// -------------------------------------------------------------------

bool OutOfRangeChange::checkValue(Real value)
{
	if (value>upperBound) 
	{	referenceValue = upperBound;
		return true;
	}

	if (value<lowerBound) 
	{	referenceValue = lowerBound;
		return true;
	}

	return false;
}

// -------------------------------------------------------------------
// From Telemeterable interface

int OutOfRangeChange::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]
								+AocsObject::getTelemetryImageLength());
}

// -------------------------------------------------------------------
// From Telemeterable interface

void OutOfRangeChange::writeToTelemetry(TelemetryStream* tmStream)
{
	AocsObject::writeToTelemetry(tmStream);		// write super object's state

	// TBD : not implemented in framework prototype
}
