// Property.cpp
//
// Version	1.0
// Date		05.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/ClassId.h"
#include "../ObjectMonitoring/Property.h"

// -------------------------------------------------------------------
// The default constructor is required to be able to pass parameters
// of type Property

Property::Property()
{	
}


// -------------------------------------------------------------------

Property::Property(Real* datum, PropertyId p)
{	
	setClassId(ID_PROPERTY);	
	realDatum=datum;
	selector=0;
	propertyId = p; 
}

// -------------------------------------------------------------------

Property::Property(int* datum, PropertyId p)
{	
	setClassId(ID_PROPERTY);	
	intDatum=datum;
	selector=1;
	propertyId = p; 
}

// -------------------------------------------------------------------

Property::Property(bool* datum, PropertyId p)
{	
	setClassId(ID_PROPERTY);	
	boolDatum=datum;
	selector=2;
	propertyId = p; 
}

// -------------------------------------------------------------------

Real Property::get()
{	
	switch (selector) 
	{	case 0:
			return *realDatum;
		case 1:
			return (Real)(*intDatum);
		case 2:
			return (Real)(*boolDatum);
	}
	return 0;	// this should never be reached
}

// -------------------------------------------------------------------

PropertyId Property::getPropertyId()
{ 
	return propertyId; 
}
