// TestPropertyMonitor.h
//
// Version	1.0
// Date		18.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Implementation of the PropertyMonitor interface to be used for 
// testing purposes.
// The TestPropertyMonitor maintains a counter that is 
// initialized to zero and incremented by one every time it
// receives a notification from the monitored object.
// -------------------------------------------------------------------

#ifndef TestPropertyMonitorH
#define TestPropertyMonitorH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../BasicObjects/AocsObject.h"
#include "../ObjectMonitoring/Property.h"
#include "../ObjectMonitoring/PropertyMonitor.h"

// -------------------------------------------------------------------

class TestPropertyMonitor : public AocsObject, public PropertyMonitor {

	int notificationCounter;

public :

	TestPropertyMonitor()
		{ notificationCounter=0;}

	virtual void propertyChange(AocsObject* changeOriginator,
								  Property monitoredProperty,
									ChangeObject* changeObject)
		{ notificationCounter++;}
	

	int getNotificationCounter()
		{ return notificationCounter; }
};


// -------------------------------------------------------------------
#endif // ReportingManoeuvreMonitorH
