// RegressionTest.cpp 
//
// Version	1.0
// Date		06.02.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Regression test for the framelets
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../GeneralUtilities/TestSuite.h"
#include "../GeneralUtilities/TestUtilities.h"
#include "../GeneralInclude/CompilerSwitches.h"

#include "../AocsData/AocsDataTest/TestCaseAocsData_1.h"
#include "../AocsData/AocsDataTest/TestCaseAocsData_2.h"
#include "../AocsData/AocsDataTest/TestCaseAocsData_3.h"
#include "../AocsData/AocsDataTest/TestCaseAocsData_4.h"
#include "../AocsData/AocsDataTest/TestCaseAocsData_5.h"
#include "../AocsData/AocsDataTest/TestCaseAocsData_6.h"
#include "../AocsData/AocsDataTest/TestCaseAocsData_7.h"
#include "../AocsData/AocsDataTest/TestCaseAocsData_8.h"

#include "../AocsEvent/AocsEventTest/TestCaseAocsEvent_1.h"
#include "../AocsEvent/AocsEventTest/TestCaseAocsEvent_2.h"
#include "../AocsEvent/AocsEventTest/TestCaseAocsEvent_3.h"
#include "../AocsEvent/AocsEventTest/TestCaseAocsEvent_4.h"
#include "../AocsEvent/AocsEventTest/TestCaseAocsEvent_5.h"

#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_1.h"
#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_2.h"
#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_3.h"
#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_4.h"
#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_5.h"
#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_6.h"
#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_7.h"
#include "../AocsUnit/AocsUnitTest/TestCaseAocsUnit_8.h"

#include "../BasicObjects/BasicObjectsTest/TestCaseAocsObject_1.h"
#include "../BasicObjects/BasicObjectsTest/TestCaseAocsObject_2.h"
#include "../BasicObjects/BasicObjectsTest/TestCaseAocsObject_3.h"
#include "../BasicObjects/BasicObjectsTest/TestCaseRootObject_1.h"
#include "../BasicObjects/BasicObjectsTest/TestCaseRootObject_2.h"

#include "../ControllerManagement/ControllerManagementTest/TestCaseController_0.h"
#include "../ControllerManagement/ControllerManagementTest/TestCaseController_1.h"
#include "../ControllerManagement/ControllerManagementTest/TestCaseController_2.h"
#include "../ControllerManagement/ControllerManagementTest/TestCaseController_3.h"
#include "../ControllerManagement/ControllerManagementTest/TestCaseController_4.h"
#include "../ControllerManagement/ControllerManagementTest/TestCaseController_5.h"

#include "../FailureDetection/FailureDetectionManagementTest/TestCaseFailureDetection_1.h"
#include "../FailureDetection/FailureDetectionManagementTest/TestCaseFailureDetection_2.h"
#include "../FailureDetection/FailureDetectionManagementTest/TestCaseFailureDetection_3.h"

#include "../FailureRecovery/FailureRecoveryManagementTest/TestCaseFailureRecovery_1.h"
#include "../FailureRecovery/FailureRecoveryManagementTest/TestCaseFailureRecovery_2.h"
#include "../FailureRecovery/FailureRecoveryManagementTest/TestCaseFailureRecovery_3.h"

#include "../ManoeuvreManagement/ManoeuvreManagementTest/TestCaseManoeuvre_1.h"
#include "../ManoeuvreManagement/ManoeuvreManagementTest/TestCaseManoeuvre_2.h"
#include "../ManoeuvreManagement/ManoeuvreManagementTest/TestCaseManoeuvre_3.h"
#include "../ManoeuvreManagement/ManoeuvreManagementTest/TestCaseManoeuvre_4.h"

#include "../ObjectList/ObjectListTest/TestCaseObjectList_1.h"
#include "../ObjectList/ObjectListTest/TestCaseObjectList_2.h"
#include "../ObjectList/ObjectListTest/TestCaseObjectList_3.h"

#include "../ObjectMonitoring/ObjectMonitoringTest/TestCaseObjectMonitoring_1.h"
#include "../ObjectMonitoring/ObjectMonitoringTest/TestCaseObjectMonitoring_2.h"

#include "../ReconfigurationManagement/ReconfigurationManagementTest/TestCaseReconfiguration_1.h"
#include "../ReconfigurationManagement/ReconfigurationManagementTest/TestCaseReconfiguration_2.h"
#include "../ReconfigurationManagement/ReconfigurationManagementTest/TestCaseReconfiguration_3.h"
#include "../ReconfigurationManagement/ReconfigurationManagementTest/TestCaseReconfiguration_4.h"

#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_1.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_2.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_3.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_4.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_5.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_6.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_7.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseControlChannel_8.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseXmathUcbBlock_1.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseXmathUcbBlock_2.h"
#include "../SequentialDataProcessing/SequentialDataProcessingTest/TestCaseXmathUcbBlock_3.h"

#include "../SystemManagement/SystemManagementTest/TestCaseSystemManagement_1.h"

#include "../TelecommandManagement/TelecommandManagementTest/TestCaseTelecommand_1.h"
#include "../TelecommandManagement/TelecommandManagementTest/TestCaseTelecommand_2.h"
#include "../TelecommandManagement/TelecommandManagementTest/TestCaseTelecommand_3.h"
#include "../TelecommandManagement/TelecommandManagementTest/TestCaseTelecommand_4.h"
#include "../TelecommandManagement/TelecommandManagementTest/TestCaseTelecommand_5.h"
#include "../TelecommandManagement/TelecommandManagementTest/TestCaseTelecommand_6.h"
#include "../TelecommandManagement/TelecommandManagementTest/TestCaseTelecommand_7.h"

#include "../TelemetryManagement/TelemetryManagementTest/TestCaseTelemetry_1.h"
#include "../TelemetryManagement/TelemetryManagementTest/TestCaseTelemetry_2.h"
#include "../TelemetryManagement/TelemetryManagementTest/TestCaseTelemetry_3.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("RegressionTestOut.txt","w")) == NULL )
      printf( "\nThe file 'RegressionTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'RegressionTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin regression test ...\n" );
	printTestHeader(out, "RegressionTest");

	// Create and load a test suite
	TestSuite testSuite(out);

	testSuite.loadTestCase(new TestCaseAocsData_1());
	testSuite.loadTestCase(new TestCaseAocsData_2());
	testSuite.loadTestCase(new TestCaseAocsData_3());
	testSuite.loadTestCase(new TestCaseAocsData_4());
	testSuite.loadTestCase(new TestCaseAocsData_5());
	testSuite.loadTestCase(new TestCaseAocsData_6());
	testSuite.loadTestCase(new TestCaseAocsData_7());
	testSuite.loadTestCase(new TestCaseAocsData_8());

	testSuite.loadTestCase(new TestCaseAocsEvent_1());
	testSuite.loadTestCase(new TestCaseAocsEvent_2());
	testSuite.loadTestCase(new TestCaseAocsEvent_3());
	testSuite.loadTestCase(new TestCaseAocsEvent_4());
	testSuite.loadTestCase(new TestCaseAocsEvent_5());
	
	testSuite.loadTestCase(new TestCaseAocsUnit_1());
	testSuite.loadTestCase(new TestCaseAocsUnit_2());
	testSuite.loadTestCase(new TestCaseAocsUnit_3());
	testSuite.loadTestCase(new TestCaseAocsUnit_4());
	testSuite.loadTestCase(new TestCaseAocsUnit_5());
	testSuite.loadTestCase(new TestCaseAocsUnit_6());
	testSuite.loadTestCase(new TestCaseAocsUnit_7());
	testSuite.loadTestCase(new TestCaseAocsUnit_8());

	testSuite.loadTestCase(new TestCaseAocsObject_1());
	testSuite.loadTestCase(new TestCaseAocsObject_2());
	testSuite.loadTestCase(new TestCaseAocsObject_3());
	testSuite.loadTestCase(new TestCaseRootObject_1());
	testSuite.loadTestCase(new TestCaseRootObject_2());

	testSuite.loadTestCase(new TestCaseController_0());
	testSuite.loadTestCase(new TestCaseController_1());
	testSuite.loadTestCase(new TestCaseController_2());
	testSuite.loadTestCase(new TestCaseController_3());
	testSuite.loadTestCase(new TestCaseController_4());
	testSuite.loadTestCase(new TestCaseController_5());

	testSuite.loadTestCase(new TestCaseFailureDetection_1());
	testSuite.loadTestCase(new TestCaseFailureDetection_2());
	testSuite.loadTestCase(new TestCaseFailureDetection_3());

	testSuite.loadTestCase(new TestCaseFailureRecovery_1());
	testSuite.loadTestCase(new TestCaseFailureRecovery_2());
	testSuite.loadTestCase(new TestCaseFailureRecovery_3());

	testSuite.loadTestCase(new TestCaseManoeuvre_1());
	testSuite.loadTestCase(new TestCaseManoeuvre_2());
	testSuite.loadTestCase(new TestCaseManoeuvre_3());
	testSuite.loadTestCase(new TestCaseManoeuvre_4());

	testSuite.loadTestCase(new TestCaseObjectList_1());
	testSuite.loadTestCase(new TestCaseObjectList_2());
	testSuite.loadTestCase(new TestCaseObjectList_3());

	testSuite.loadTestCase(new TestCaseObjectMonitoring_1());
	testSuite.loadTestCase(new TestCaseObjectMonitoring_2());

	testSuite.loadTestCase(new TestCaseReconfiguration_1());
	testSuite.loadTestCase(new TestCaseReconfiguration_2());
	testSuite.loadTestCase(new TestCaseReconfiguration_3());
	testSuite.loadTestCase(new TestCaseReconfiguration_4());

	testSuite.loadTestCase(new TestCaseControlChannel_1());
	testSuite.loadTestCase(new TestCaseControlChannel_2());
	testSuite.loadTestCase(new TestCaseControlChannel_3());
	testSuite.loadTestCase(new TestCaseControlChannel_4());
	testSuite.loadTestCase(new TestCaseControlChannel_5());
	testSuite.loadTestCase(new TestCaseControlChannel_6());
	testSuite.loadTestCase(new TestCaseControlChannel_7());
	testSuite.loadTestCase(new TestCaseControlChannel_8());
	testSuite.loadTestCase(new TestCaseXmathUcbBlock_1());
	testSuite.loadTestCase(new TestCaseXmathUcbBlock_2());
	testSuite.loadTestCase(new TestCaseXmathUcbBlock_3());

	testSuite.loadTestCase(new TestCaseSystemManagement_1());

	testSuite.loadTestCase(new TestCaseTelecommand_1());
	testSuite.loadTestCase(new TestCaseTelecommand_2());
	testSuite.loadTestCase(new TestCaseTelecommand_3());
	testSuite.loadTestCase(new TestCaseTelecommand_4());
	testSuite.loadTestCase(new TestCaseTelecommand_5());
	testSuite.loadTestCase(new TestCaseTelecommand_6());
	testSuite.loadTestCase(new TestCaseTelecommand_7());

	testSuite.loadTestCase(new TestCaseTelemetry_1());
	testSuite.loadTestCase(new TestCaseTelemetry_2());
	testSuite.loadTestCase(new TestCaseTelemetry_3());

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nRegression test ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}