/*  CppInterface.c
 *	
 *  Test the interface between C++ and rtems.
 *  The initialization task calls the RootObject test suite.
 *
 */

/* Include files and declarations for the RootObject test */

#include <stdio.h>

#include "../GeneralInclude/Include.h"
#include "../GeneralUtilities/TestUtilities.h"
#include "../BasicObjects/RootObject.h"
#include "../BasicObjects/RootObjectTest/RootObjectTestSuite.h"

/* Include file for rtems environment */

#include <tmacros.h>

/* Specify C linkage for initialization routine (called by rtems exec) */

extern "C" {
   rtems_task Init( rtems_task_argument argument);
}

/* rtems configuration information */

#define TEST_INIT
#define CONFIGURE_SPTEST

#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER

#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
#define CONFIGURE_INIT

#include <confdefs.h>

//RootObject dummy;	// This causes the program to fail ....

/* Initialization task for this test program called from init_exec */

rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_status_code status;
  rtems_time_of_day time;

  puts( "\n\n*** C++ Interface Test ***" );

  rootObjectTestMaster((FILE*)0);

  status = rtems_task_delete( RTEMS_SELF );
}

