// AdderBlock.cpp
//
// Version	1.0
// Date	13.10.00
// Author	T. Brown
//
// Change History:
//
// -------------------------------------------------------------------

// Include framework header files
#include "../SequentialDataProcessing/AdderBlock.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/Constants.h"

int AdderBlock::tmImageLength[NTMFORMATS] = {0, 0, 0, 0};

// -------------------------------------------------------------------
// Default constructor.
AdderBlock::AdderBlock()
{
	setClassId(ID_ADDERBLOCK);		// assign class identifier

	allocateMemory(2,1,0);				// 2 inputs, 1 output, 0 states

	localResetConfiguration();
}

// -------------------------------------------------------------------

void AdderBlock::propagationAlgorithm(AocsTime t)
{
	output[0] = input[0] + input[1];
}

// -------------------------------------------------------------------

void AdderBlock::localResetConfiguration()
{
	return;
}

// -------------------------------------------------------------------

void AdderBlock::resetConfiguration()
{
	ControlChannelBlock::resetConfiguration();	// reset super object's state
	localResetConfiguration();
}

// -------------------------------------------------------------------

void AdderBlock::writeToTelemetry(TelemetryStream* stream)
{
	// write super object's state
	ControlChannelBlock::writeToTelemetry(stream);

	// TBD - not done in prototype
}

// -------------------------------------------------------------------

int AdderBlock::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]+
			ControlChannelBlock::getTelemetryImageLength());
}


