// DifferenceBlock.cpp
//
// Version	1.0
// Date	13.10.00
// Author	T. Brown
//
// Change History:
//
// -------------------------------------------------------------------

// Include framework header files
#include "../SequentialDataProcessing/DifferenceBlock.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/Constants.h"

int DifferenceBlock::tmImageLength[NTMFORMATS] = {0, 0, 0, 0};

// -------------------------------------------------------------------
// Default constructor.
DifferenceBlock::DifferenceBlock()
{
	setClassId(ID_DIFFERENCEBLOCK);		// assign class identifier

	allocateMemory(2,1,0);				// 2 inputs, 1 output, 0 states

	localResetConfiguration();
}

// -------------------------------------------------------------------

void DifferenceBlock::propagationAlgorithm(AocsTime t)
{
	output[0] = input[1] - input[0];
}

// -------------------------------------------------------------------

void DifferenceBlock::localResetConfiguration()
{
	return;
}

// -------------------------------------------------------------------

void DifferenceBlock::resetConfiguration()
{
	ControlChannelBlock::resetConfiguration();	// reset super object's state
	localResetConfiguration();
}

// -------------------------------------------------------------------

void DifferenceBlock::writeToTelemetry(TelemetryStream* stream)
{
	// write super object's state
	ControlChannelBlock::writeToTelemetry(stream);

	// TBD - not done in prototype
}

// -------------------------------------------------------------------

int DifferenceBlock::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]+
			ControlChannelBlock::getTelemetryImageLength());
}


