// PassThruBlock.h
//
// Version	1.0
// Date		13.10.00
// Author	T. Brown
//
// Change History:
//
// -------------------------------------------------------------------
// Control block to implement a simple simple pass thru block
//
// The block implements the following single-input-single-output
// transfer function: y = u0
//
// -------------------------------------------------------------------

#ifndef PassThruBlockH
#define PassThruBlockH

// -------------------------------------------------------------------

#include "../SequentialDataProcessing/ControlChannelBlock.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class PassThruBlock : public ControlChannelBlock {

	static ClassId classId;
	static int tmImageLength[NTMFORMATS];

	virtual void propagationAlgorithm(AocsTime t);

public :

	PassThruBlock();

	virtual int getTelemetryImageLength();
	virtual void writeToTelemetry(TelemetryStream* stream);
};

#endif // PassThruBlockH
