// RawBusDataConverterOut.cpp
//
// Version	1.0
// Date		30.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

// Include framework header files
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/ClassId.h"
#include "../SequentialDataProcessing/RawBusDataConverterOut.h"

// -------------------------------------------------------------------

RawBusDataConverterOut::RawBusDataConverterOut(int m, Real r)				
{
	setClassId(ID_RAWBUSDATACONVERTEROUT);				

	resolutionLevel = r;
	numberOfChannels = m;

	allocateMemory(numberOfChannels,numberOfChannels,0);	
				// numberOfChannels inputs and outputs, 0 states
					
}

// -------------------------------------------------------------------

void RawBusDataConverterOut::propagationAlgorithm(AocsTime t)
{
	unsigned short* rawDatum;
	unsigned short mask = 0x8000;
	
	for (int i=0; i<numberOfChannels; i++)
	{	rawDatum = (unsigned short*)&output[i];

		if (input[i]>0)
		{	(*rawDatum) = (unsigned short) (input[i]*resolutionLevel);
			(*rawDatum) = ((*rawDatum) | mask);
		}
		else
		{	(*rawDatum) = (unsigned short) (-input[i]*resolutionLevel);
			(*rawDatum) = ((*rawDatum) & 0x7FFF);
		}
	}
}

