// DummyBlock_Double.cpp
//
// Version	1.0
// Date		18.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

// Include framework header files
#include "../../GeneralInclude/Include.h"
#include "../../TelemetryManagement/Telemeterable.h"
#include "../../BasicObjects/Include.h"
#include "../../OperatingSystemObjects/Runnable.h"
#include "../../OperatingSystemObjects/AocsClock.h"
#include "../../FailureDetection/ConsistencyCheckable.h"
#include "../../AocsEvent/Include.h"
#include "../../AocsData/Include.h"
#include "../../SequentialDataProcessing/Include.h"

// Include test headers
#include "Include.h"

const int NULL=0;

// -------------------------------------------------------------------
// Default constructor.

DummyBlock_Double::DummyBlock_Double()				
{
	setClassId(ID_DUMMYBLOCKDOUBLE);		// assign class identifier

	allocateMemory(1,1,0);					// 1 input, 1 output, 0 states

	initialize();							// see comment at the method definition

	reset();								// see comment on AocsData constructor
	resetConfiguration();					// see comment on AocsData constructor
}

// -------------------------------------------------------------------

void DummyBlock_Double::propagationAlgorithm(AocsTime t)
{
	output[0] = 2* input[0];
}
