// AttitudeSlewTelecommand.h
//
// Version	1.0
// Date		25.11.00
// Author	A. Pasetti

#ifndef AttitudeSlewTelecommandH
#define AttitudeSlewTelecommandH

// -------------------------------------------------------------------
// Telecommand to configure and load an attitude slew manoeuvre in 
// the manoeuvre manager.
// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../TelecommandManagement/Telecommand.h"

// -------------------------------------------------------------------

class AttitudeSlewTelecommand : public Telecommand {

	AttitudeSlew* manoeuvre;

	// Attitude Slew Configuration Parameters
	float errorThreshold;
	float att_end;
	AocsTime t0;
	AocsTime tf;
	Real* itemToSet;
	AocsTime* timeTagItemToSet;

	static ManoeuvreManager* manoeuvreManager;

public :

	AttitudeSlewTelecommand(AocsTime timeTag, AttitudeSlew* m, float errorThreshold,
							float att_end, AocsTime t0, AocsTime tf,
							Real* itemToSet, AocsTime* timeTagItemToSet);

	virtual EventType execute();

	static void setManoeuvreManager(ManoeuvreManager* mm)
		{ manoeuvreManager = mm; }
	static ManoeuvreManager* getManoeuvreManager()
		{ return manoeuvreManager; }
};

// -------------------------------------------------------------------
#endif