// ManoeuvreTelecommand.h
//
// Version	1.0
// Date		25.11.00
// Author	A. Pasetti

#ifndef ManoeuvreTelecommandH
#define ManoeuvreTelecommandH

// -------------------------------------------------------------------
// Telecommand to load a parameterless manoeuvre in the manoeuvre 
// manager.
// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../TelecommandManagement/Telecommand.h"

// -------------------------------------------------------------------

class ManoeuvreTelecommand : public Telecommand {

	Manoeuvre* manoeuvre;
	static ManoeuvreManager* manoeuvreManager;

public :

	ManoeuvreTelecommand(AocsTime timeTag, Manoeuvre* m);

	virtual EventType execute();

	static void setManoeuvreManager(ManoeuvreManager* mm)
		{ manoeuvreManager = mm; }
	static ManoeuvreManager* getManoeuvreManager()
		{ return manoeuvreManager; }
};

// -------------------------------------------------------------------
#endif