// ModeChangeTelecommand.cpp
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../TelecommandManagement/ModeChangeTelecommand.h"
#include "../ModeManagement/ModeManager.h"
#include "../GeneralInclude/ClassId.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------

ModeChangeTelecommand::ModeChangeTelecommand(
	 AocsTime timeTag, ModeManager* m, int n):Telecommand(timeTag)
{
	setClassId(ID_MODECHANGETELECOMMAND);			

	modeManager = m;
	newMode = (unsigned char)n;
}

// -------------------------------------------------------------------

EventType ModeChangeTelecommand::execute()
{
	modeManager->setMode(newMode);

	// Check whether mode change was successful
	if (modeManager->getMode() != (int)newMode)
		return TC_FAILURE;
	else
		return TC_SUCCESS;
}
