// ModeChangeTransactionTelecommand.h
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti

#ifndef ModeChangeTransactionTelecommandH
#define ModeChangeTransactionTelecommandH

// -------------------------------------------------------------------
// Telecommand Transaction to change the operational mode of a mode manager.
// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../TelecommandManagement/TransactionTelecommand.h"

// -------------------------------------------------------------------

class ModeChangeTransactionTelecommand : public TransactionTelecommand {

	ModeManager* modeManager;
	unsigned char newMode;

public :

	ModeChangeTransactionTelecommand(AocsTime timeTag, ModeManager* m, int n);

	virtual EventType execute();

	virtual EventType unExecute();
};

// -------------------------------------------------------------------
#endif