// ReconfigureTelecommand.cpp
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../TelecommandManagement/ReconfigureTelecommand.h"
#include "../ReconfigurationManagement/Reconfigurable.h"
#include "../GeneralInclude/ClassId.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------

ReconfigureTelecommand::ReconfigureTelecommand(
	 AocsTime timeTag, Reconfigurable* r):Telecommand(timeTag)
{
	setClassId(ID_RECONFIGURETELECOMMAND);			

	reconfigurationManager = r;
}

// -------------------------------------------------------------------

EventType ReconfigureTelecommand::execute()
{
	// Recover current configuration
	ConfigurationId oldConfig = reconfigurationManager->getConfiguration();

	// Command reconfiguration
	reconfigurationManager->reconfigure();

	// Check whether reconfiguration was successful
	if (reconfigurationManager->getConfiguration() == oldConfig)
		return TC_FAILURE;
	else
		return TC_SUCCESS;
}
