// TelecommandLoader.h
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// This is an interface class
// -------------------------------------------------------------------

#ifndef TelecommandLoaderH
#define TelecommandLoaderH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../OperatingSystemObjects/Runnable.h"

// -------------------------------------------------------------------

class TelecommandLoader : public Runnable {

public:

    // Release the memory allocated to TC
    virtual void release(TelecommandId TcId) = 0;

    // Release all memory allocated to TC's
    virtual void releaseAll() = 0;

    // Getter and setter methods for the TC manager
	virtual void setTelecommandManager(TelecommandManager* m) = 0;
	virtual TelecommandManager* getTelecommandManager() = 0;
};

// -------------------------------------------------------------------
#endif