// TelemetryFormatTelecommand.cpp
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../TelecommandManagement/TelemetryFormatTelecommand.h"
#include "../TelemetryManagement/Telemeterable.h"
#include "../GeneralInclude/ClassId.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------

TelemetryFormatTelecommand::TelemetryFormatTelecommand(
	 AocsTime timeTag, Telemeterable* t, TelemetryFormat n):
		Telecommand(timeTag)
{
	setClassId(ID_TELEMETRYFORMATTELECOMMAND);			

	telemeterable = t;
	newFormat = n;
}

// -------------------------------------------------------------------

EventType TelemetryFormatTelecommand::execute()
{
	telemeterable->setTelemetryFormat(newFormat);

	// Check whether telemetry format change was successful
	if (telemeterable->getTelemetryFormat() == newFormat)
		return TC_SUCCESS;
	else
		return TC_FAILURE;
}
