// TestTelecommandLoader.h
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Dummy impleplementation of interface TelecommandLoader to be used 
// during framelet testing.
// The only implemented functionality is a counter that is initialized
// to 0 and incremented by 1 every time method release(...) is called.
// -------------------------------------------------------------------

#ifndef TestTelecommandLoaderH
#define TestTelecommandLoaderH

// -------------------------------------------------------------------

#include "../TelecommandManagement/TelecommandLoader.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/Constants.h"

// -------------------------------------------------------------------

class TestTelecommandLoader : public TelecommandLoader {

	int counter;

public:

	TestTelecommandLoader()
		{ counter = 0; }

	virtual void release(TelecommandId TcId)
		{ counter++; }

	virtual void releaseAll()
		{ return; }

	virtual Telecommand* getReference(TelecommandId tcId)
		{ return NULL; }

	int getReleaseCounter()
		{ return counter; }

	void run(AocsTime t)
		{ return; }

	void setTelecommandManager(TelecommandManager* m)
		{ return; }
	TelecommandManager* getTelecommandManager()
		{ return NULL; }
};

// -------------------------------------------------------------------
#endif