// TelemetryStreamOnGround.h
//
// Version	1.0
// Date		17.01.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// This is an interface class representing a telemetry stream as seen
// by the ground
// -------------------------------------------------------------------

#ifndef TelemetryStreamOnGroundH
#define TelemetryStreamOnGroundH

// -------------------------------------------------------------------

class TelemetryStreamOnGround {

protected :

	virtual int readFrameNumber()=0;			 
	virtual int readNumberOfBytes(int n)=0;		
	virtual int readNumberOfBits(int n)=0;		

public:

	virtual char	readChar()=0;			
	virtual double	readDouble()=0;					
	virtual float	readFloat()=0;					
	virtual int		readInt()=0;					
	virtual short	writeShort()=0;					
	virtual bool	writeBool()=0;					
	virtual unsigned int  writeUnsignedInt()=0;			
	virtual unsigned short writeUnsignedShort()=0;			
	virtual unsigned char writeUnsignedChar()=0;			
};

// -------------------------------------------------------------------
#endif