/****************************************************************************
|                   AutoCode/C (TM) Code Generator
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/c_tpl/ramptest.rtf
Filename               : /a/estwns/users/esther/pasetti/c_tpl/ramptest.h
Dac filename           : c_sdk.dac
Generated on           : Fri Mar  3 12:29:34 2000
Dac file created on    : Fri Mar  3 12:29:33 2000

                AutoCode Procedure Software Development Kit

Procedure Name                   Inputs  Outputs  INFO  States
--------------------------------------------------------------
ramp                             NO      YES      YES   YES

*/

#ifndef _TOPLEVEL_RAMP_H_
#define _TOPLEVEL_RAMP_H_

#include "sa_sys.h"
#include "sa_types.h"



/******* Procedure: ramp *******/

/***** Outputs type declaration. *****/
struct _ramp_y {
   RT_FLOAT ramp_2_1;
};


/***** Private States type declaration. *****/
struct _ramp_ps {
   RT_FLOAT ramp_2_S1;
};


/***** States type declaration. *****/
struct _ramp_s {
   struct _ramp_ps ramp_ps[2];
   RT_INTEGER ramp_x;
};


/***** Info type declaration. *****/
struct _ramp_info {
   RT_INTEGER iinfo[5];
   RT_FLOAT rinfo[5];
   VAR_FLOAT *starttime;
   VAR_FLOAT *slope;
   VAR_FLOAT *integratorgain;
   VAR_FLOAT *integratorinit;
};






/* *********************************************************************
   ************************ I N T E R F A C E S ************************
   *********************************************************************
*/

/*
**
**  Interfaces to: ramp
**
*/

struct _ramp_ext {
     struct _ramp_info ramp_i;
     struct _ramp_s    ramp_s_s;
};


/* Function: ramp_Initialize
**
** Abstract: Initialize procedure's private data
**
** Parameters: _idata (in) : ptr to an instance of
**                           procedure's interface data
**
*/ 
extern void ramp_Initialize(struct _ramp_ext *_idata);




/* Function: ramp_Execute
**
** Abstract: Execute the procedure
**
** Parameters: Procedure's input and output variables
**             Instance of interface structure
**             Current time may be needed as well.
**             Interface varies for each procedure.
**
** Returns: error status, 0 = no error, 
**          else see errors in sa_defn.h
**
*/
extern RT_INTEGER ramp_Execute(
                    struct _ramp_y *Y,
                    RT_FLOAT TIME,
                    struct _ramp_ext *_idata);
                    





#endif

