/****************************************************************************
|                   AutoCode/C (TM) Code Generator
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/cpp_tpl/pid.rtf
Filename               : /a/estwns/users/esther/pasetti/cpp_tpl/pid.h
Dac filename           : cpp_sdk.dac
Generated on           : Fri Mar  3 12:26:21 2000
Dac file created on    : Fri Mar  3 12:26:21 2000

                AutoCode Procedure Software Development Kit

Procedure Name                   Inputs  Outputs  INFO  States
--------------------------------------------------------------
pid                              YES     YES      YES   YES

*/

#ifndef _TOPLEVEL_PID_H_
#define _TOPLEVEL_PID_H_

#include "sa_sys.h"
#include "sa_types.h"



/******* Procedure: pid *******/

/***** Inputs type declaration. *****/
struct _pid_u {
   RT_FLOAT pid_1;
};


/***** Outputs type declaration. *****/
struct _pid_y {
   RT_FLOAT pid_1;
};


/***** Private States type declaration. *****/
struct _pid_ps {
   RT_FLOAT pid_S1;
   RT_FLOAT pid_S2;
};


/***** States type declaration. *****/
struct _pid_s {
   struct _pid_ps pid_ps[2];
   RT_INTEGER pid_x;
};


/***** Info type declaration. *****/
struct _pid_info {
   RT_INTEGER iinfo[5];
   RT_FLOAT rinfo[5];
   VAR_FLOAT *kp;
   VAR_FLOAT *ki;
   VAR_FLOAT *kd;
   VAR_FLOAT *timeconstant;
};







// /////////////////////////////////////////////////////////////
// /////////////////////////////////////////////////////////////
// /////////////////////////////////////////////////////////////
// /////////////////////////////////////////////////////////////

//
//
//  CLASS: pid_proxy
//
//
class pid_proxy
{

/////
///// methods
/////
public:

    
    /////// Default Constructor
    //
    pid_proxy();
    
    
    //Function: Execute
    //
    // Abstract: Execute the procedure
    //
    // Parameters: Procedure's input and output variables
    //             Current time may be needed as well.
    //             Interface varies for each procedure.
    //
    // Returns: error status, 0 = no error, 
    //          else see errors in sa_defn.h
    //
    //
    RT_INTEGER Execute(
                    struct _pid_u *U,
                    struct _pid_y *Y,
                    RT_FLOAT TIME);
                    

/////
/////  private data
/////
private:

    struct _pid_ext {
         struct _pid_info pid_i;
         struct _pid_s    pid_s_s;
    } m_procdata;
    

};




#endif

