/****************************************************************************
|                   AutoCode/C (TM) Code Generator 62mx1118
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : firsttesttop.rtf
Filename               : firsttesttop.c
Dac filename           : /opt/ISIHOME/solaris_mx_62.2/case/ACC/templates/c_sim.dac
Generated on           : Tue Feb 29 13:24:00 2000
Dac file created on    : Thu Nov 18 18:45:46 1999
Options                : -l c -procs


*/



#include <stdio.h>
#include <math.h>
#include "sa_sys.h"
#include "sa_defn.h"
#include "sa_types.h"
#include "sa_math.h"
#include "sa_matrix.h"
#include "sa_user.h"
#include "sa_utils.h"
#include "sa_time.h"
#include "sa_fuzzy.h"



// Control flag to avoid compilation of subsys version of autocode routine
#define SBUSER	1		// added by A. Pasetti




/*** System Data ***/

/******* Structure to drive disconnected input/output. *******/






#define EPSILON                      1.49011611938476562E-08
#define EPS                          (4.0 * EPSILON)
#define ABSTOL                       EPSILON
#define XREMAP                       1




/******** Procedures' declarations ********/

/******* Procedure: firsttest *******/

/***** Inputs type declaration. *****/
struct _firsttest_u {
   RT_FLOAT firsttest_1;
   RT_FLOAT firsttest_2;
};


/***** Outputs type declaration. *****/
struct _firsttest_y {
   RT_FLOAT Summer_1;
};


/***** Private States type declaration. *****/
struct _firsttest_ps {
   RT_FLOAT Delay_S1;
};


/***** States type declaration. *****/
struct _firsttest_s {
   struct _firsttest_ps firsttest_ps[2];
   RT_INTEGER firsttest_x;
};


/***** Info type declaration. *****/
struct _firsttest_info {
   RT_INTEGER iinfo[5];
   RT_FLOAT rinfo[5];
};





extern void firsttest(struct _firsttest_u *U, struct _firsttest_y *Y, struct _firsttest_s *S, struct _firsttest_info *I);


/******** Procedures' definitions ********/

/******* Procedure: firsttest *******/
void firsttest(   struct _firsttest_u *U
   ,struct _firsttest_y *Y
   ,struct _firsttest_s *S
   ,struct _firsttest_info *I
)
{
      RT_INTEGER *iinfo = &I->iinfo[0];
      RT_FLOAT *rinfo = &I->rinfo[0];
      RT_INTEGER INIT = iinfo[1];

      /***** Current and Next States Pointers. *****/

      struct _firsttest_ps *X = &S->firsttest_ps[S->firsttest_x];
      struct _firsttest_ps *XD = &S->firsttest_ps[1-S->firsttest_x];

      const RT_DURATION TSAMP   = rinfo[1];

      /***** Local Block Outputs. *****/

      RT_FLOAT Delayoutput;

      /***** Algorithmic Local Variables. *****/

      RT_FLOAT Xtemp;
      RT_INTEGER i;
      RT_INTEGER j;
      RT_INTEGER k;

      /******* Initialization. *******/

      if( INIT ) {
         X->Delay_S1 = 0.0;
         XD->Delay_S1 = 0.0;
         Delayoutput = 99.0;
      }


      /***** Output Update. *****/
      /* ----------------------------  Num - Den Coeffs. */
      /* {firsttest.Delay.2} */
      if (!INIT) {
         Delayoutput = X->Delay_S1; 
      }
      /* ----------------------------  Summer */
      /* {firsttest.Summer.12} */
      Y->Summer_1 = Delayoutput - U->firsttest_2; 

      /***** State Update. *****/
      /* ----------------------------  Num - Den Coeffs. */
      /* {firsttest.Delay.2} */
      if (INIT && XREMAP) {
         Xtemp = Delayoutput; 
         X->Delay_S1 = Xtemp; 
      }
      XD->Delay_S1 = U->firsttest_1; 


      iinfo[1] = 0;

EXEC_ERROR: return;
}



static void Init_Application_Data ()
{
   RT_INTEGER cnt;

     /* Declare %var/varblk initialization data */


}


#ifndef SBUSER

#define NTASKS                        1
static RT_INTEGER                     ERROR_FLAG  [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_PREINIT [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_INIT [NTASKS+1];

/******* System Ext I/O type declarations. *******/
struct _Subsys_1_out {
   RT_FLOAT firsttest_2_1;
};

struct _Sys_ExtIn {
   RT_FLOAT firsttesttop_1;
   RT_FLOAT firsttesttop_2;
};





/*****************************************************************************/
/* (Subsystem-style) Wrapper (subsys_1) around procedure(s):                 */
/*                    firsttest()                                            */
/* to support invoking it from a user application.                           */
/*****************************************************************************/

extern void subsys_1(  struct _Sys_ExtIn *U, struct _Subsys_1_out *Y);


/******* Subsystem 1  *******/


void subsys_1(   struct _Sys_ExtIn *U
   ,struct _Subsys_1_out *Y
)
{
      static RT_INTEGER iinfo[4];
      static RT_INTEGER INIT;
      const RT_DURATION TSAMP = 0.1;
      static struct _firsttest_u firsttest_2_u;
      static struct _firsttest_y firsttest_2_y;
      static struct _firsttest_s firsttest_2_s;
      static struct _firsttest_info firsttest_2_i;

      /******* Initialization. *******/

      if (SUBSYS_PREINIT[1]) {
         iinfo[0] = 0; 
         iinfo[1] = 1; 
         iinfo[2] = 1; 
         iinfo[3] = 1; 
         INIT = 1; 
         firsttest_2_s.firsttest_x = 0;
         firsttest_2_i.iinfo[0] = iinfo[0];
         firsttest_2_i.iinfo[1] = iinfo[1];
         firsttest_2_i.iinfo[3] = iinfo[3];
         firsttest_2_i.rinfo[1] = (RT_FLOAT)TSAMP;
         SUBSYS_PREINIT[1] = FALSE; 
         return;
      }

      /***** Output Update. *****/
      /* ----------------------------  Procedure Super Block */
      /* {firsttest.2} */
      firsttest_2_u.firsttest_1 = U->firsttesttop_1;
      firsttest_2_u.firsttest_2 = U->firsttesttop_2;
      firsttest(&firsttest_2_u, &firsttest_2_y, &firsttest_2_s, &firsttest_2_i)
         ;
      firsttest_2_s.firsttest_x = 1 - firsttest_2_s.firsttest_x;
      Y->firsttest_2_1 = firsttest_2_y.Summer_1;
      iinfo[0] = firsttest_2_i.iinfo[0];
      if( iinfo[0] != 0 ) {
         firsttest_2_i.iinfo[0] = 0; goto EXEC_ERROR;
      }
      INIT = 0;

      iinfo[1] = 0;
      return;

EXEC_ERROR: ERROR_FLAG[1] = iinfo[0];
      iinfo[0]=0;
}

#endif /* SBUSER */



/* Required for linking generated procedures with SystemBuild simulator. */

#if (FC_)
#ifdef SBUSER
#define firsttest_ucbhook firsttest_ucbhook_
#endif
#endif

#ifdef PC
#define firsttest_ucbhook FIRSTTEST_UCBHOOK
extern void FIRSTTEST_UCBHOOK();
#else
extern void firsttest_ucbhook();
#endif





/*****************************************************************************/
/* (UCB-style) Wrapper around the procedure to support UCB (Fixed calltype)  */
/* interface.                                                                */
/* This routine may be called as a UCB from SystemBuild.                     */
/*****************************************************************************/

/*****************************************************************************/
/* $ucb(firsttest,hook,firsttest_ucbhook)                                    */
/* Map                                                                       */
/* ---                                                                       */
/* Number of Inputs:                     2                                   */
/* Number of Outputs:                    1                                   */
/* Number of States:                     1                                   */
/* Number of Integer parameters (I_P):   0                                   */
/* Number of Real parameters    (R_P):   0                                   */
/* Number of constant (xmath) variables: 0                                   */
/*                                                                           */
/*                                                                           */
/* Integer (I_P) and real (R_P) parameters will automatically be             */
/* initialized by procedures invoked by this wrapper.  However, enough I_P   */
/* and R_P space needs to be allocated (use map above) for initializing and  */
/* storing new parameter values.                                             */
/*****************************************************************************/


void firsttest_ucbhook(iinfo, rinfo, U, NU, X, XD ,NX, Y, NY, R_P, I_P)
   int     iinfo[], I_P[], *NU, *NX, *NY;
   double  rinfo[], R_P[], U[], X[], XD[], Y[];
{
   static struct _firsttest_u firsttest_2_u;
   static struct _firsttest_y firsttest_2_y;
   static struct _firsttest_s firsttest_2_s;
   static struct _firsttest_info firsttest_2_i;

   struct _firsttest_s *firsttest_s;
   struct _firsttest_ps *firsttest_ps;



   if( (*NU != 2) || (*NY != 1) || (*NX != 1) ) {
      iinfo[0] = UCB_ERROR; goto EXEC_ERROR;
   }
   if( iinfo[1] == 1 ) {
      Init_Application_Data();
      if( iinfo[3] == 1 && *NX != 0 ) {
         return;
      }
   }

   /* Not all SIM init-modes supported */
   if( iinfo[1] > 1 ) {
      return;
   }

   /* ---------------------------- Procedure Super Block */
   /* {firsttest.2} */
   firsttest_2_u.firsttest_1 = U[0];
   firsttest_2_u.firsttest_2 = U[1];


   /* Copy in states of procedure firsttest */
   firsttest_2_s.firsttest_x = 0;
   firsttest_ps = &firsttest_2_s.firsttest_ps[0];
   firsttest_ps->Delay_S1 = X[0];

   /* Copy in status and control data of procedure firsttest */
   firsttest_2_i.iinfo[0] = iinfo[0];
   firsttest_2_i.iinfo[1] = iinfo[1];
   firsttest_2_i.iinfo[3] = iinfo[3];
   firsttest_2_i.rinfo[1] = rinfo[1];

   firsttest(&firsttest_2_u, &firsttest_2_y, &firsttest_2_s, &firsttest_2_i);
   Y[0] = firsttest_2_y.Summer_1;


   /* Copy out states of procedure firsttest */
   firsttest_ps = &firsttest_2_s.firsttest_ps[1];
   XD[0] = firsttest_ps->Delay_S1;

   /*  Copy back into states  */
   if( iinfo[1] == 1 ) {
      
      /* Copy in states of procedure firsttest */
      firsttest_2_s.firsttest_x = 0;
      firsttest_ps = &firsttest_2_s.firsttest_ps[0];
      X[0] = firsttest_ps->Delay_S1;
   }


   iinfo[0] = firsttest_2_i.iinfo[0];
EXEC_ERROR: return;
}





