/****************************************************************************
|                   AutoCode/C (TM) Code Generator 62mx1118
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : pid.rtf
Filename               : pid.c
Dac filename           : /opt/ISIHOME/solaris_mx_62.2/case/ACC/templates/c_sim.dac
Generated on           : Fri Mar 17 14:29:59 2000
Dac file created on    : Thu Nov 18 18:45:46 1999
Options                : -l c -procs


*/



#include <stdio.h>
#include <math.h>
#include "sa_sys.h"
#include "sa_defn.h"
#include "sa_types.h"
#include "sa_math.h"
#include "sa_matrix.h"
#include "sa_user.h"
#include "sa_utils.h"
#include "sa_time.h"
#include "sa_fuzzy.h"



// Control flag to avoid compilation of subsys version of autocode routine
#define SBUSER	1		// added by A. Pasetti



/*** System Data ***/

/******* Structure to drive disconnected input/output. *******/






#define EPSILON                      1.49011611938476562E-08
#define EPS                          (4.0 * EPSILON)
#define ABSTOL                       EPSILON
#define XREMAP                       1


/* Xmath variable definitions. */
VAR_FLOAT kp;
VAR_FLOAT ki;
VAR_FLOAT kd;
VAR_FLOAT timeconstant;
/* Xmath variable declarations. */
extern VAR_FLOAT kp;
extern VAR_FLOAT ki;
extern VAR_FLOAT kd;
extern VAR_FLOAT timeconstant;


/******** Procedures' declarations ********/

/******* Procedure: pid *******/

/***** Inputs type declaration. *****/
struct _pid_u {
   RT_FLOAT pid_1;
};


/***** Outputs type declaration. *****/
struct _pid_y {
   RT_FLOAT pid_1;
};


/***** Private States type declaration. *****/
struct _pid_ps {
   RT_FLOAT pid_S1;
   RT_FLOAT pid_S2;
};


/***** States type declaration. *****/
struct _pid_s {
   struct _pid_ps pid_ps[2];
   RT_INTEGER pid_x;
};


/***** Info type declaration. *****/
struct _pid_info {
   RT_INTEGER iinfo[5];
   RT_FLOAT rinfo[5];
   VAR_FLOAT *kp;
   VAR_FLOAT *ki;
   VAR_FLOAT *kd;
   VAR_FLOAT *timeconstant;
};





extern void pid(struct _pid_u *U, struct _pid_y *Y, struct _pid_s *S, struct _pid_info *I);


/******** Procedures' definitions ********/

/******* Procedure: pid *******/
void pid(   struct _pid_u *U
   ,struct _pid_y *Y
   ,struct _pid_s *S
   ,struct _pid_info *I
)
{
      RT_INTEGER *iinfo = &I->iinfo[0];
      RT_FLOAT *rinfo = &I->rinfo[0];
      RT_INTEGER INIT = iinfo[1];

      /***** Current and Next States Pointers. *****/

      struct _pid_ps *X = &S->pid_ps[S->pid_x];
      struct _pid_ps *XD = &S->pid_ps[1-S->pid_x];

      const RT_DURATION TSAMP   = rinfo[1];

      /***** Algorithmic Local Variables. *****/

      RT_FLOAT xn;

      /******* Initialization. *******/

      if( INIT ) {
         X->pid_S1 = 0.0;
         X->pid_S2 = 0.0;
         XD->pid_S1 = 0.0;
         XD->pid_S2 = 0.0;
      }


      /***** Output Update. *****/
      /* ----------------------------  PID Controller */
      /* {pid.pid.3} */
      if (XREMAP) {
         if (INIT) {
            X->pid_S2 = X->pid_S2 - TSAMP*U->pid_1; 
            X->pid_S1 = (-((*I->timeconstant) + TSAMP)/(*I->kd)*X->pid_S1 + U->
         pid_1)/TSAMP; 
         }
      }
      Y->pid_1 = U->pid_1*(*I->kp); 
      xn = X->pid_S2 + TSAMP*U->pid_1; 
      Y->pid_1 = Y->pid_1 + xn*(*I->ki); 
      Y->pid_1 = Y->pid_1 + (U->pid_1 - TSAMP*X->pid_S1)*(*I->kd)/((*I->
         timeconstant) + TSAMP); 

      /***** State Update. *****/
      /* ----------------------------  PID Controller */
      /* {pid.pid.3} */
      XD->pid_S2 = X->pid_S2 + TSAMP*U->pid_1; 
      XD->pid_S1 = ((*I->timeconstant)*X->pid_S1 + U->pid_1)/((*I->timeconstant)
         + TSAMP); 


      iinfo[1] = 0;

EXEC_ERROR: return;
}



static void Init_Application_Data ()
{
   RT_INTEGER cnt;

     /* Declare %var/varblk initialization data */

     /* Xmath variables initialization. */
     kp = 1000.0;
     ki = 0.001;
     kd = 0.001;	
     timeconstant = 0.0;


}


#ifndef SBUSER

#define NTASKS                        1
static RT_INTEGER                     ERROR_FLAG  [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_PREINIT [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_INIT [NTASKS+1];

/******* System Ext I/O type declarations. *******/
struct _Subsys_1_out {
   RT_FLOAT pid_2_1;
};

struct _Sys_ExtIn {
   RT_FLOAT pidtop_1;
};





/*****************************************************************************/
/* (Subsystem-style) Wrapper (subsys_1) around procedure(s):                 */
/*                    pid()                                                  */
/* to support invoking it from a user application.                           */
/*****************************************************************************/

extern void subsys_1(  struct _Sys_ExtIn *U, struct _Subsys_1_out *Y);


/******* Subsystem 1  *******/


void subsys_1(   struct _Sys_ExtIn *U
   ,struct _Subsys_1_out *Y
)
{
      static RT_INTEGER iinfo[4];
      static RT_INTEGER INIT;
      const RT_DURATION TSAMP = 0.1;
      static struct _pid_u pid_2_u;
      static struct _pid_y pid_2_y;
      static struct _pid_s pid_2_s;
      static struct _pid_info pid_2_i;
      struct _pid_info *pid_i;

      /******* Initialization. *******/

      if (SUBSYS_PREINIT[1]) {
         iinfo[0] = 0; 
         iinfo[1] = 1; 
         iinfo[2] = 1; 
         iinfo[3] = 1; 
         INIT = 1; 
         pid_2_s.pid_x = 0;
         pid_2_i.iinfo[0] = iinfo[0];
         pid_2_i.iinfo[1] = iinfo[1];
         pid_2_i.iinfo[3] = iinfo[3];
         pid_2_i.rinfo[1] = (RT_FLOAT)TSAMP;

         /* Copy in variable pointers of procedure pid */
         pid_2_i.kp = &kp;
         pid_2_i.ki = &ki;
         pid_2_i.kd = &kd;
         pid_2_i.timeconstant = &timeconstant;
         SUBSYS_PREINIT[1] = FALSE; 
         return;
      }

      /***** Output Update. *****/
      /* ----------------------------  Procedure Super Block */
      /* {pid.2} */
      pid_2_u.pid_1 = U->pidtop_1;
      pid(&pid_2_u, &pid_2_y, &pid_2_s, &pid_2_i);
      pid_2_s.pid_x = 1 - pid_2_s.pid_x;
      Y->pid_2_1 = pid_2_y.pid_1;
      iinfo[0] = pid_2_i.iinfo[0];
      if( iinfo[0] != 0 ) {
         pid_2_i.iinfo[0] = 0; goto EXEC_ERROR;
      }
      INIT = 0;

      iinfo[1] = 0;
      return;

EXEC_ERROR: ERROR_FLAG[1] = iinfo[0];
      iinfo[0]=0;
}

#endif /* SBUSER */



/* Required for linking generated procedures with SystemBuild simulator. */

#if (FC_)
#ifdef SBUSER
#define pid_ucbhook pid_ucbhook_
#endif
#endif

#ifdef PC
#define pid_ucbhook PID_UCBHOOK
extern void PID_UCBHOOK();
#else
extern void pid_ucbhook();
#endif





/*****************************************************************************/
/* (UCB-style) Wrapper around the procedure to support UCB (Fixed calltype)  */
/* interface.                                                                */
/* This routine may be called as a UCB from SystemBuild.                     */
/*****************************************************************************/

/*****************************************************************************/
/* $ucb(pid,hook,pid_ucbhook)                                                */
/* Map                                                                       */
/* ---                                                                       */
/* Number of Inputs:                     1                                   */
/* Number of Outputs:                    1                                   */
/* Number of States:                     2                                   */
/* Number of Integer parameters (I_P):   0                                   */
/* Number of Real parameters    (R_P):   0                                   */
/* Number of constant (xmath) variables: 4                                   */
/*                                                                           */
/*                                                                           */
/* Integer (I_P) and real (R_P) parameters will automatically be             */
/* initialized by procedures invoked by this wrapper.  However, enough I_P   */
/* and R_P space needs to be allocated (use map above) for initializing and  */
/* storing new parameter values.                                             */
/*****************************************************************************/


void pid_ucbhook(iinfo, rinfo, U, NU, X, XD ,NX, Y, NY, R_P, I_P)
   int     iinfo[], I_P[], *NU, *NX, *NY;
   double  rinfo[], R_P[], U[], X[], XD[], Y[];
{
   static struct _pid_u pid_2_u;
   static struct _pid_y pid_2_y;
   static struct _pid_s pid_2_s;
   static struct _pid_info pid_2_i;

   struct _pid_s *pid_s;
   struct _pid_ps *pid_ps;

   struct _pid_info *pid_i;


   if( (*NU != 1) || (*NY != 1) || (*NX != 2) ) {
      iinfo[0] = UCB_ERROR; goto EXEC_ERROR;
   }
   if( iinfo[1] == 1 ) {
      Init_Application_Data();
      if( iinfo[3] == 1 && *NX != 0 ) {
         return;
      }
   }

   /* Not all SIM init-modes supported */
   if( iinfo[1] > 1 ) {
      return;
   }

   /* ---------------------------- Procedure Super Block */
   /* {pid.2} */
   pid_2_u.pid_1 = U[0];


   /* Copy in states of procedure pid */
   pid_2_s.pid_x = 0;
   pid_ps = &pid_2_s.pid_ps[0];
   pid_ps->pid_S1 = X[0];
   pid_ps->pid_S2 = X[1];

   /* Copy in status and control data of procedure pid */
   pid_2_i.iinfo[0] = iinfo[0];
   pid_2_i.iinfo[1] = iinfo[1];
   pid_2_i.iinfo[3] = iinfo[3];
   pid_2_i.rinfo[1] = rinfo[1];

   /* Copy in variable pointers of procedure pid */
   pid_2_i.kp = &kp;
   pid_2_i.ki = &ki;
   pid_2_i.kd = &kd;
   pid_2_i.timeconstant = &timeconstant;

   pid(&pid_2_u, &pid_2_y, &pid_2_s, &pid_2_i);
   Y[0] = pid_2_y.pid_1;


   /* Copy out states of procedure pid */
   pid_ps = &pid_2_s.pid_ps[1];
   XD[0] = pid_ps->pid_S1;
   XD[1] = pid_ps->pid_S2;

   /*  Copy back into states  */
   if( iinfo[1] == 1 ) {
      
      /* Copy in states of procedure pid */
      pid_2_s.pid_x = 0;
      pid_ps = &pid_2_s.pid_ps[0];
      X[0] = pid_ps->pid_S1;
      X[1] = pid_ps->pid_S2;
   }


   iinfo[0] = pid_2_i.iinfo[0];
EXEC_ERROR: return;
}





