/*----------------------------------------------------------------------------
--                       AutoCode (TM) 62mx1118
--
--                         Copyright (C) 1999
--                       INTEGRATED SYSTEMS, INC.
--
--  Unpublished work - rights reserved under the U.S. Copyright Act.  Use,
--  duplication, or disclosure by the government is subject to restrictions
--  set forth in the ISI commercial license agreement.
**----------------------------------------------------------------------------
**
**  File       : sa_defn.h
**  Project    : Autocode/C
**
**  Abstract:
**
**      Definitions for AutoCode files.
*/

/* Modification added by AP for compatibility with ERC32 environment
*/


#ifndef _SA_DEFN
#define _SA_DEFN

#include "sa_sys.h"
#include "sa_types.h"

#define FC_ (SOLARIS || SUN || SUNV || DEC || SGI || IG || APOUNIX || OSF1)

#if !defined(PI)
#define PI                            3.141592653589793
#endif
#define E1                            2.718281828
#define ZERO                          0
#define ONE                           1

#ifdef MS_HOST		// AP: for compatibility with ERC32 environment, 20.06.00
#define FALSE                         0
#define TRUE                          1
#endif

#define RELTOL                        0.001
#define STOL                          0.001
#define OK                            0
#define STOP_BLOCK                    1
#define MATH_ERROR                    2
#define STOPPED                       3
#define UCB_ERROR                     -2    /* sameas SYSBLD */
#define RANGE_ERROR                   5 
#define SHAREDMEM_ERROR               6
#define TIME_OVERFLOW                -1
#define UNKNOWN_ERROR                 100
#define PSOS_ERROR                    200
#define BYTE_SIZE                     8
#define WORD_SIZE                     16
#define LWORD_SIZE                    32
#define POSITIVE                      0
#define NEGATIVE                      1 


/*** Platform specific defines ***/

#if (DEC||OSF1)
#define const
#define Volatile                 volatile
#endif

#if  (VAX||SGI||IBM||HP300||METAWARE||PGI860||_TMS320C30||_TMS320C40||BORLANDC||MSWIN32||MSVC32)
#define Constant                 const
#define Volatile                 volatile
#endif

#if  (SUN||SOLARIS||HP||HP700||APOLLO)
#define Constant
#define const
#define Volatile
#define volatile
#endif

#if (_TMS320C30||_TMS320C40)
#define BITSPERBYTE	32
#elif gcos
#define BITSPERBYTE	9
#else
#define BITSPERBYTE	8
#endif
#define BITS(type)	(BITSPERBYTE * (int)sizeof(type))


#endif
